!# libxlsxwriter for Clarion 1.5
!# () RaFaeL 2017
!# based on libxlsxwriter.dll 1.1.4
!# https://libxlsxwriter.github.io 

 MAP
  MODULE('WIN API')
    XLSX:GetSysColor(SIGNED),ULONG,PASCAL,NAME('GetSysColor')
    XLSX:WideCharToMultiByte(long,long,long,long,long,long,long,long),LONG,PASCAL,RAW,PROC,NAME('WideCharToMultiByte')
    XLSX:MultiByteToWideChar(long,long,long,long,long,long),LONG,PASCAL,RAW,PROC,NAME('MultiByteToWideChar')
  END

  MODULE('xlsxwriter.clw')
    XLSX:FormDateTime(*XLSX:datetime dt_,LONG date_,LONG time_)
    XLSX:FormLine(*XLSX:chart_line_ line_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
    XLSX:FormFill(*XLSX:chart_fill fill_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
    XLSX:FormFont(*XLSX:chart_font font_,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
    XLSX:RGBColor(LONG color),LONG
    XLSX:GetSystemColor(LONG Color),LONG
    XLSX:Normalize(STRING In_,BYTE valchar_=95),STRING
  END
 END

COMPILE('***',_TPICTLinkMode_)
 include('tpicture.inc'),once
***

 include('xlsxequates.inc')

XLSX:NoBorder EQUATE(255)

XLSX:Border  GROUP,TYPE
Format        BYTE(XLSX:NoBorder)
Color         LONG(COLOR:NONE)
             END

XLSX:datetime GROUP,TYPE
year           LONG
month          LONG
day            LONG
hour           LONG
min            LONG
padding        LONG
sec            REAL
              END

XLSX:imageoptions GROUP,TYPE
x_offset           LONG
y_offset           LONG
x_scale            REAL
y_scale            REAL
object_position    BYTE
padding1           BYTE
padding2           SHORT
description        LONG
decorative         BYTE
padding3           BYTE
padding4           SHORT
url                LONG
tip                LONG
                  END

XLSX:chartoptions GROUP,TYPE
x_offset           LONG
y_offset           LONG
x_scale            REAL
y_scale            REAL
object_position    BYTE
padding1           BYTE
padding2           SHORT
description        LONG
decorative         BYTE
                  END

XLSX:commentoptions GROUP,TYPE
visible            BYTE
padding1           BYTE
padding2           SHORT
author             LONG
width              SHORT
height             SHORT
padding3           LONG
x_scale            REAL
y_scale            REAL
color              LONG
font_name          LONG
font_size          REAL
font_family        BYTE
padding4           BYTE
padding5           SHORT
start_row          LONG
start_col          SHORT
padding7           SHORT
x_offset           LONG
y_offset           LONG
                  END

XLSX:hf_options GROUP,TYPE
margin           REAL
image_left       LONG
image_center     LONG
image_right      LONG
                END

XLSX:rc_options GROUP,TYPE
hidden           BYTE
level            BYTE
collapsed        BYTE
                END

XLSX:doc_properties GROUP,TYPE
title                LONG
subject              LONG
author               LONG
manager              LONG
company              LONG
category             LONG
keywords             LONG
comments             LONG
status               LONG
hyperlink_base       LONG
created              LONG
                    END

XLSX:rule       GROUP,TYPE
criteria          BYTE
padding           BYTE
padding2          SHORT
value_string      LONG
value             REAL
                END

XLSX:button     GROUP,TYPE
caption           LONG
macro             LONG
description       LONG
width             USHORT
height            USHORT
x_scale           REAL
y_scale           REAL
x_offset          LONG
y_offset          LONG
                END

XLSX:chart_line_ GROUP,TYPE
color             LONG
none              BYTE
padding1          BYTE
padding2          SHORT
width             SREAL
dash_type         BYTE
transparency      BYTE
                 END

XLSX:chart_fill GROUP,TYPE
color            LONG
none             BYTE
transparency     BYTE
                END

XLSX:chart_pattern GROUP,TYPE
fg_color            LONG
bg_color            LONG
type                BYTE
                   END

XLSX:chart_font    GROUP,TYPE
name                LONG
padding1            LONG
size                REAL
bold                BYTE
italic              BYTE
underline           BYTE
padding2            BYTE
rotation            LONG
color               LONG
pitch_family        BYTE
charset             BYTE
baseline            SHORT
                   END

XLSX:Point      GROUP,TYPE
line              GROUP(XLSX:chart_line_)
                  END
fill              GROUP(XLSX:chart_fill)
                  END
pattern           GROUP(XLSX:chart_pattern)
                  END
is_custom         BYTE
                END

XLSX:Label      GROUP,TYPE
value             CSTRING(101)
hide              BYTE
font              GROUP(XLSX:chart_font)
                  END
line              GROUP(XLSX:chart_line_)
                  END
fill              GROUP(XLSX:chart_fill)
                  END
pattern           GROUP(XLSX:chart_pattern)
                  END
is_custom         BYTE
                END

XLSX:FormatType GROUP,TYPE
Color            LONG
FGColor          LONG
Border           GROUP(XLSX:Border)
                 END
Left             GROUP(XLSX:Border)
                 END
Top              GROUP(XLSX:Border)
                 END
Right            GROUP(XLSX:Border)
                 END
Bottom           GROUP(XLSX:Border)
                 END
Diag             GROUP(XLSX:Border)
Type              BYTE
                 END
FontName         CSTRING(101)
FontSize         REAL
FontColor        LONG
FontStyle        LONG
Underline        BYTE
FontScript       BYTE
Align            BYTE
AlignV           BYTE
WrapText         BYTE
Rotation         SHORT
Indent           BYTE
Shrink           BYTE
Pattern          BYTE
Picture          CSTRING(101)
ExcelMask        CSTRING(101)
Index            BYTE
Hidden           BYTE
Unlocked         BYTE
                END

XLSX:FormatQ QUEUE,TYPE
FormatG       GROUP(XLSX:FormatType)
              END
Ref           LONG
             END

XLSX:RichStringTupleQ QUEUE,TYPE
Cstr                     &CSTRING
Format                  LONG
                      END

XLSX:FilterQ    QUEUE,TYPE
Cstr               &CSTRING
                END

xlsxwriter                    CLASS, TYPE, MODULE('xlsxwriter.clw'), LINK('xlsxwriter.clw')
Workbook                        LONG
ActiveSheet                     LONG
ActiveSheetName                 CSTRING(256)
IsChartsheet                    BYTE
Filename                        CSTRING(256)

Properties                      GROUP
title                             CSTRING(256)
subject                           CSTRING(256)
author                            CSTRING(256)
manager                           CSTRING(256)
company                           CSTRING(256)
category                          CSTRING(256)
keywords                          CSTRING(256)
comments                          CSTRING(256)
status                            CSTRING(256)
hyperlink_base                    CSTRING(256)
created_date                      LONG
created_time                      LONG
                                END

ActiveFormat                    LONG

BreaksH                         LONG,DIM(1024)
BreaksV                         SHORT,DIM(1024)

Format                          GROUP(XLSX:FormatType)
                                END

FormatQ                         &XLSX:FormatQ
RichStringTupleQ                &XLSX:RichStringTupleQ
FilterQ                         &XLSX:FilterQ
 COMPILE('***',_TPictureClassPresent_)
Picture                         &TPictureClass
 ***
Cstr                            &CSTRING
UTF8                            BYTE

Construct                       PROCEDURE
Destruct                        PROCEDURE
NewWorkbook                     PROCEDURE(STRING filename_,<BYTE constant_memory_>)
AddSheet                        PROCEDURE(STRING sheetname_,<BYTE is_chartsheet_>),LONG,PROC
CloseWorkbook                   PROCEDURE(),LONG,PROC
ReadOnlyRecommended             PROCEDURE()
SetProperties                   PROCEDURE(),LONG,PROC
SetCustomProperty               PROCEDURE(STRING name_,<STRING string_>,<REAL number_>,<BYTE boolean_>,<LONG date_>),LONG,PROC
DefineName                      PROCEDURE(STRING name_,STRING formula_),LONG,PROC
GetSheetByName                  PROCEDURE(STRING sheetname_),LONG,PROC
ValidateSheetName               PROCEDURE(STRING sheetname_),LONG,PROC
AddVBAProject                   PROCEDURE(STRING filename_),LONG,PROC
SetVBAName                      PROCEDURE(STRING name_),LONG,PROC
GetDefaultURLFormat             PROCEDURE()

WriteNumber                     PROCEDURE(LONG row_,SHORT col_,REAL number_),LONG,PROC
WriteBoolean                    PROCEDURE(LONG row_,SHORT col_,SHORT value_),LONG,PROC
WriteString                     PROCEDURE(LONG row_,SHORT col_,STRING string_),LONG,PROC
WriteUrl                        PROCEDURE(LONG row_,SHORT col_,STRING url_,<STRING string_>),LONG,PROC
WriteBlank                      PROCEDURE(LONG row_,SHORT col_),LONG,PROC
WriteDateTime                   PROCEDURE(LONG row_,SHORT col_,LONG date_,LONG time_),LONG,PROC
WriteFormula                    PROCEDURE(LONG row_,SHORT col_,STRING formula_,<REAL result>,<STRING result_str_>),LONG,PROC
WriteArrayFormula               PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_,STRING formula_,<REAL result>),LONG,PROC
WriteDynamicFormula             PROCEDURE(LONG row_,SHORT col_,STRING formula_,<REAL result>),LONG,PROC
WriteDynamicArrayFormula        PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_,STRING formula_,<REAL result>),LONG,PROC
WriteComment                    PROCEDURE(LONG row_,SHORT col_,STRING string_,<BYTE visible_>,<STRING author_>,<SHORT width_>,<SHORT height_>,<REAL x_scale_>,<REAL y_scale_>,<LONG color_>,<STRING font_name_>,<REAL font_size_>,<BYTE font_family_>,<LONG start_row_>,<SHORT start_col_>,<LONG x_offset_>,<LONG y_offset_>),LONG,PROC
NewRichString                   PROCEDURE
AddToRichString                 PROCEDURE(STRING str_,LONG format_)
WriteRichString                 PROCEDURE(LONG row_,SHORT col_),LONG,PROC
WriteRichStrings                PROCEDURE(LONG row_,SHORT col_,LONG records_),LONG,PROC
Merge                           PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_,<STRING string_>),LONG,PROC
Autofilter                      PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_),LONG,PROC
FilterColumn                    PROCEDURE(SHORT col_,BYTE criteria_,<STRING value_str_>,<REAL value_>,<BYTE criteria2_>,<STRING value_str2_>,<REAL value2_>,<BYTE and_or_>),LONG,PROC
AddToFilterList                 PROCEDURE(STRING str_)
ClearFilterList                 PROCEDURE
WriteFilter                     PROCEDURE(SHORT col_,LONG records_),LONG,PROC
FilterList                      PROCEDURE(SHORT col_),LONG,PROC
SetSelection                    PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_)
SetColumn                       PROCEDURE(SHORT first_col_,SHORT last_col_,REAL width_=XLSX:DEF_COL_WIDTH,<BYTE hidden_>,<BYTE level_>,<BYTE collapsed_>),LONG,PROC
SetRow                          PROCEDURE(LONG row_,REAL height_=XLSX:DEF_ROW_HEIGHT,<BYTE hidden_>,<BYTE level_>,<BYTE collapsed_>),LONG,PROC
SetColumnPixels                 PROCEDURE(SHORT first_col_,SHORT last_col_,LONG width_=XLSX:DEF_COL_WIDTH_PIXELS,<BYTE hidden_>,<BYTE level_>,<BYTE collapsed_>),LONG,PROC
SetRowPixels                    PROCEDURE(LONG row_,LONG height_=XLSX:DEF_ROW_HEIGHT_PIXELS,<BYTE hidden_>,<BYTE level_>,<BYTE collapsed_>),LONG,PROC
OutlineSettings                 PROCEDURE(BYTE visible_,BYTE symbols_below_,BYTE symbols_right_,BYTE auto_style_)
ClearFormat                     PROCEDURE()
SetFormat                       PROCEDURE(BYTE active_=1),LONG,PROC
SetZoom                         PROCEDURE(SHORT scale_)
SetPrintScale                   PROCEDURE(SHORT scale_)
SetStartPage                    PROCEDURE(SHORT start_page_)
Gridlines                       PROCEDURE(BYTE option_)
FreezePanes                     PROCEDURE(LONG row_,SHORT col_)
SplitPanes                      PROCEDURE(REAL vertical_,REAL horizontal_)
RightToLeft                     PROCEDURE()
HideZero                        PROCEDURE()
Activate                        PROCEDURE()
Select                          PROCEDURE()
Hide                            PROCEDURE()
SetFirstSheet                   PROCEDURE()
SetTopleftCell                  PROCEDURE(LONG row_,SHORT col_)
ShowComments                    PROCEDURE()
SetSheetVBAName                 PROCEDURE(STRING name_),LONG,PROC
SetChart                        PROCEDURE(LONG chart_)
SetBackground                   PROCEDURE(STRING filename_),LONG,PROC
SetBackgroundBuffer             PROCEDURE(*STRING image_,ULONG image_size_),LONG,PROC
InsertImage                     PROCEDURE(LONG row_,SHORT col_,STRING filename_,<LONG x_offset_>,<LONG y_offset_>,<REAL x_scale_>,<REAL y_scale_>,<BYTE object_position_>,<STRING description_>,<BYTE decorative_>,<STRING url_>,<STRING tip_>),LONG,PROC
InsertImageBuffer               PROCEDURE(LONG row_,SHORT col_,*STRING image_,ULONG image_size_,<LONG x_offset_>,<LONG y_offset_>,<REAL x_scale_>,<REAL y_scale_>,<BYTE object_position_>,<STRING description_>,<BYTE decorative_>,<STRING url_>,<STRING tip_>),LONG,PROC
InsertChart                     PROCEDURE(LONG row_,SHORT col_,LONG chart_,<LONG x_offset_>,<LONG y_offset_>,<REAL x_scale_>,<REAL y_scale_>,<BYTE object_position_>,<STRING description_>,<BYTE decorative_>),LONG,PROC
InsertButton                    PROCEDURE(LONG row_,SHORT col_,<STRING caption_>,<STRING macro_>,<STRING description_>,<USHORT width_>,<USHORT height_>,<REAL x_scale_>,<REAL y_scale_>,<LONG x_offset_>,<LONG y_offset_>),LONG,PROC
PrintAcross                     PROCEDURE()
PrintRowColHeaders              PROCEDURE()
PrintArea                       PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_),LONG,PROC
RepeatRows                      PROCEDURE(LONG first_row_,LONG last_row_),LONG,PROC
RepeatColumns                   PROCEDURE(SHORT first_col_,SHORT last_col_),LONG,PROC
FitToPages                      PROCEDURE(SHORT width_,SHORT height_)
AddPagebreakV                   PROCEDURE(SHORT col_)
AddPagebreakH                   PROCEDURE(LONG row_)
SetPagebreaksV                  PROCEDURE(),LONG,PROC
SetPagebreaksH                  PROCEDURE(),LONG,PROC
SetTabColor                     PROCEDURE(LONG color_)
SetLandscape                    PROCEDURE()
SetPortrait                     PROCEDURE()
SetPaper                        PROCEDURE(BYTE paper_type_)
SetCenterHorizontally           PROCEDURE()
SetCenterVertically             PROCEDURE()
SetPageView                     PROCEDURE()
SetMargins                      PROCEDURE(<REAL left_>,<REAL right_>,<REAL top_>,<REAL bottom_>)
SetHeader                       PROCEDURE(STRING string_,<REAL margin_>,<STRING image_left_>,<STRING image_center_>,<STRING image_right_>),LONG,PROC
SetFooter                       PROCEDURE(STRING string_,<REAL margin_>,<STRING image_left_>,<STRING image_center_>,<STRING image_right_>),LONG,PROC
SetCommentsAuthor               PROCEDURE(STRING string_),LONG,PROC
DataValidation                  PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_,BYTE validate_,BYTE criteria_,STRING value_,<STRING maximum_value_>,|
                                    <BYTE ignore_blank_>,<BYTE show_input_>,<BYTE show_error_>,<BYTE error_type_>,<BYTE dropdown_>,<STRING input_title_>,<STRING input_message_>,<STRING error_title_>,<STRING error_message_>),LONG,PROC
ConditionalFormat               PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_,BYTE type_,BYTE criteria_,<REAL value_>,<STRING value_string_>,|
                                    <REAL min_value_>,<STRING min_value_string_>,<BYTE min_rule_type_>,<LONG min_color_>,|
                                    <REAL mid_value_>,<STRING mid_value_string_>,<BYTE mid_rule_type_>,<LONG mid_color_>,|
                                    <REAL max_value_>,<STRING max_value_string_>,<BYTE max_rule_type_>,<LONG max_color_>,|
                                    <LONG bar_color_>,<BYTE bar_only_>,<BYTE data_bar_2010_>,<BYTE bar_solid_>,|
                                    <LONG bar_negative_color_>,<LONG bar_border_color_>,<LONG bar_negative_border_color_>,<LONG bar_negative_color_same_>,<LONG bar_negative_border_color_same>,|
                                    <BYTE bar_no_border_>,<BYTE bar_direction_>,<BYTE bar_axis_position_>,<LONG bar_axis_color_>,|
                                    <BYTE icon_style_>,<BYTE reverse_icons_>,<BYTE icons_only_>,<BYTE stop_if_true_>),LONG,PROC

Protect                         PROCEDURE(<STRING password_>,<BYTE no_select_locked_cells_>,<BYTE no_select_unlocked_cells>,|
                                    <BYTE format_cells_>,<BYTE format_columns_>,<BYTE format_rows_>,<BYTE insert_columns_>,<BYTE insert_rows_>,<BYTE insert_hyperlinks_>,|
                                    <BYTE delete_columns_>,<BYTE delete_rows_>,<BYTE sort_>,<BYTE autofilter_>,<BYTE pivot_tables_>,<BYTE scenarios_>,<BYTE objects>,<BYTE no_content_>,<BYTE no_objects_>)

IgnoreErrors                    PROCEDURE(BYTE type_,STRING range_),LONG
StrError                        PROCEDURE(LONG error_num_),STRING
ToUTF8                          PROCEDURE(STRING str_)
                              END

xlsxchart                    CLASS, TYPE, MODULE('xlsxwriter.clw'), LINK('xlsxwriter.clw')

Chart                           LONG
XAxis                           LONG
YAxis                           LONG
Xlsx                            &xlsxwriter
Points                          GROUP(XLSX:Point),DIM(255)
                                END
CustomLabels                    GROUP(XLSX:Label),DIM(255)
                                END
ToDelete                        BYTE,DIM(255)
Construct                       PROCEDURE
Destruct                        PROCEDURE
AddChart                        PROCEDURE(*xlsxwriter xlsxwriter_,BYTE chart_type_)
AddSeries                       PROCEDURE,LONG

SetCategories                   PROCEDURE(LONG series_,*CSTRING sheetname_,LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_)
SetValues                       PROCEDURE(LONG series_,*CSTRING sheetname_,LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_)
SetName                         PROCEDURE(LONG series_,STRING name_)
SetNameRange                    PROCEDURE(LONG series_,*CSTRING sheetname_,LONG row_,SHORT col_)
SetLine                         PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetFill                         PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
SetInvertIfNegative             PROCEDURE(LONG series_)
SetPattern                      PROCEDURE(LONG series_,LONG fg_color_,LONG bg_color_,BYTE type_)
SetMarkerType                   PROCEDURE(LONG series_,BYTE type_)
SetMarkerSize                   PROCEDURE(LONG series_,BYTE size_)
SetMarkerLine                   PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetMarkerFill                   PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
SetMarkerPattern                PROCEDURE(LONG series_,LONG fg_color_,LONG bg_color_,BYTE type_)
SetSmooth                       PROCEDURE(LONG series_,BYTE smooth_)
SetLabels                       PROCEDURE(LONG series_,BYTE name_,BYTE category_,BYTE value_)
SetLabelsSeparator              PROCEDURE(LONG series_,BYTE separator_)
SetLabelsPosition               PROCEDURE(LONG series_,BYTE position_)
SetLabelsLeaderLine             PROCEDURE(LONG series_)
SetLabelsLegend                 PROCEDURE(LONG series_)
SetLabelsPercentage             PROCEDURE(LONG series_)
SetLabelsFont                   PROCEDURE(LONG series_,<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
SetLabelsNumFormat              PROCEDURE(LONG series_,<STRING ExcelMask_>,<STRING picture_>)
SetLabelsLine                   PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetLabelsFill                   PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
SetLabelsPattern                PROCEDURE(LONG series_,LONG fg_color_,LONG bg_color_,BYTE type_)
SetTrendline                    PROCEDURE(LONG series_,BYTE type_,BYTE value_)
SetTrendlineForecast            PROCEDURE(LONG series_,REAL forward_,REAL backward_)
SetTrendlineEquation            PROCEDURE(LONG series_)
SetTrendlineRSquared            PROCEDURE(LONG series_)
SetTrendlineIntercept           PROCEDURE(LONG series_,REAL intercept_)
SetTrendlineName                PROCEDURE(LONG series_,STRING name_)
SetTrendlineLine                PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)

SetTitleName                    PROCEDURE(STRING name_)
SetTitleNameRange               PROCEDURE(*CSTRING sheetname_,LONG row_,SHORT col_)
SetTitleNameFont                PROCEDURE(<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
SetTitleOff                     PROCEDURE
SetLegendPosition               PROCEDURE(BYTE position_)
SetLegendFont                   PROCEDURE(<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
SetChartareaLine                PROCEDURE(<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetChartareaFill                PROCEDURE(<LONG color_>,<BYTE none_>,<BYTE transparency_>)
SetChartareaPattern             PROCEDURE(LONG fg_color_,LONG bg_color_,BYTE type_)
SetPlotareaLine                 PROCEDURE(<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetPlotareaFill                 PROCEDURE(<LONG color_>,<BYTE none_>,<BYTE transparency_>)
SetPlotareaPattern              PROCEDURE(LONG fg_color_,LONG bg_color_,BYTE type_)
SetStyle                        PROCEDURE(BYTE style_)
SetTable                        PROCEDURE(BYTE horizontal,BYTE vertical,BYTE outline,BYTE legend_keys)
SetRotation                     PROCEDURE(USHORT rotation)
SetHoleSize                     PROCEDURE(BYTE size_)
ShowBlanksAs                    PROCEDURE(BYTE option_)
ShowHiddenData                  PROCEDURE()
SetDropLines                    PROCEDURE(<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetHighLowLines                 PROCEDURE(<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetOverlap                      PROCEDURE(SHORT overlap_)
SetGap                          PROCEDURE(USHORT gap_)

SetAxisName                     PROCEDURE(LONG axis_,STRING name_)
SetAxisNameRange                PROCEDURE(LONG axis_,*CSTRING sheetname_,LONG row_,SHORT col_)
SetAxisNameFont                 PROCEDURE(LONG axis_,<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
SetAxisNumFont                  PROCEDURE(LONG axis_,<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
SetAxisNumFormat                PROCEDURE(LONG axis_,<STRING ExcelMask_>,<STRING picture_>)
SetAxisLine                     PROCEDURE(LONG axis_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetAxisFill                     PROCEDURE(LONG axis_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
SetAxisPattern                  PROCEDURE(LONG axis_,LONG fg_color_,LONG bg_color_,BYTE type_)
SetAxisReverse                  PROCEDURE(LONG axis_)
SetAxisCrossing                 PROCEDURE(LONG axis_,REAL value_)
SetAxisCrossingMax              PROCEDURE(LONG axis_)
SetAxisCrossingMin              PROCEDURE(LONG axis_)
SetAxisOff                      PROCEDURE(LONG axis_)
SetAxisPosition                 PROCEDURE(LONG axis_,BYTE position_)
SetAxisLabelPosition            PROCEDURE(LONG axis_,BYTE position_)
SetAxisLabelAlign               PROCEDURE(LONG axis_,BYTE align_)
SetAxisMin                      PROCEDURE(LONG axis_,REAL min_)
SetAxisMax                      PROCEDURE(LONG axis_,REAL max_)
SetAxisLogBase                  PROCEDURE(LONG axis_,SHORT log_base_)
SetAxisMajorTickMark            PROCEDURE(LONG axis_,BYTE type_)
SetAxisMinorTickMark            PROCEDURE(LONG axis_,BYTE type_)
SetAxisIntervalUnit             PROCEDURE(LONG axis_,SHORT unit_)
SetAxisIntervalTick             PROCEDURE(LONG axis_,SHORT type_)
SetAxisMajorUnit                PROCEDURE(LONG axis_,REAL unit_)
SetAxisMinorUnit                PROCEDURE(LONG axis_,REAL unit_)
SetAxisDisplayUnits             PROCEDURE(LONG axis_,BYTE type_)
SetAxisDisplayUnitsVisible      PROCEDURE(LONG axis_,BYTE visible_)
SetAxisMajorGridlinesVisible    PROCEDURE(LONG axis_,BYTE visible_)
SetAxisMinorGridlinesVisible    PROCEDURE(LONG axis_,BYTE visible_)
SetAxisMajorGridlinesLine       PROCEDURE(LONG axis_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetAxisMinorGridlinesLine       PROCEDURE(LONG axis_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)

GetErrorBars                    PROCEDURE(LONG series_,BYTE type_),LONG
SetErrorBars                    PROCEDURE(LONG error_bars_,BYTE type_,REAL value_)
SetErrorBarsDirection           PROCEDURE(LONG error_bars_,BYTE direction_)
SetErrorBarsEndcap              PROCEDURE(LONG error_bars_,BYTE endcap_)
SetErrorBarsLine                PROCEDURE(LONG error_bars_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)

SetPointLine                    PROCEDURE(BYTE num_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetPointFill                    PROCEDURE(BYTE num_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
SetPointPattern                 PROCEDURE(BYTE num_,LONG fg_color_,LONG bg_color_,BYTE type_)
SetPoints                       PROCEDURE(LONG series_,BYTE limit_=255),LONG,PROC

SetCustomLabel                  PROCEDURE(BYTE num_,<STRING value_>,<BYTE hide_>)
SetCustomLabelFont              PROCEDURE(BYTE num_,<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
SetCustomLabelLine              PROCEDURE(BYTE num_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
SetCustomLabelFill              PROCEDURE(BYTE num_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
SetCustomLabelPattern           PROCEDURE(BYTE num_,LONG fg_color_,LONG bg_color_,BYTE type_)
SetCustomLabels                 PROCEDURE(LONG series_,BYTE limit_=255),LONG,PROC

SetUpDownBars                   PROCEDURE(<*XLSX:chart_line_ up_bar_line_>,<*XLSX:chart_fill up_bar_fill_>,<*XLSX:chart_line_ down_bar_line_>,<*XLSX:chart_fill down_bar_fill_>)

SetLegendSeriesToDelete         PROCEDURE(BYTE num_)
DeleteLegendSeries              PROCEDURE(),LONG,PROC
                             END