  MEMBER

  PRAGMA('link (libxlsxw.lib)')

  INCLUDE('xlsxwriter.inc')

  MAP
     MODULE('libxlsxwriter.dll')
       workbook_new(*CSTRING filename),LONG,RAW,C,NAME('workbook_new')
       workbook_new_opt(*CSTRING filename,LONG options),LONG,RAW,C,NAME('workbook_new_opt')
       workbook_add_worksheet(LONG workbook,*CSTRING sheetname),LONG,RAW,C,NAME('workbook_add_worksheet')
       workbook_add_chartsheet(LONG workbook,*CSTRING sheetname),LONG,RAW,C,NAME('workbook_add_chartsheet')
       workbook_add_format(LONG workbook),LONG,RAW,C,NAME('workbook_add_format')
       workbook_add_chart(LONG workbook,BYTE chart_type),LONG,RAW,C,NAME('workbook_add_chart')
       workbook_close(LONG workbook),LONG,RAW,C,NAME('workbook_close')
       workbook_read_only_recommended(LONG workbook),RAW,C,NAME('workbook_read_only_recommended')
       workbook_set_properties(LONG workbook,*XLSX:doc_properties properties),LONG,RAW,C,NAME('workbook_set_properties')
       workbook_set_custom_property_string(LONG workbook,*CSTRING name,*CSTRING value),LONG,RAW,C,NAME('workbook_set_custom_property_string')
       workbook_set_custom_property_number(LONG workbook,*CSTRING name,REAL value),LONG,RAW,C,NAME('workbook_set_custom_property_number')
       workbook_set_custom_property_boolean(LONG workbook,*CSTRING name,BYTE value),LONG,RAW,C,NAME('workbook_set_custom_property_boolean')
       workbook_set_custom_property_datetime(LONG workbook,*CSTRING name,*XLSX:DATETIME value),LONG,RAW,C,NAME('workbook_set_custom_property_datetime')
       workbook_define_name(LONG workbook,*CSTRING name,*CSTRING formula),LONG,RAW,C,NAME('workbook_define_name')
       workbook_get_worksheet_by_name(LONG workbook,*CSTRING sheetname),LONG,RAW,C,NAME('workbook_get_worksheet_by_name')
       workbook_get_chartsheet_by_name(LONG workbook,*CSTRING sheetname),LONG,RAW,C,NAME('workbook_get_chartsheet_by_name')
       workbook_validate_sheet_name(LONG workbook,*CSTRING sheetname),LONG,RAW,C,NAME('workbook_validate_sheet_name')
       workbook_add_vba_project(LONG workbook,*CSTRING filename),LONG,RAW,C,NAME('workbook_add_vba_project')
       workbook_set_vba_name(LONG workbook,*CSTRING vbaname),LONG,RAW,C,NAME('workbook_set_vba_name')
       workbook_get_default_url_format(LONG workbook),LONG,RAW,C,NAME('workbook_get_default_url_format')

       worksheet_write_number(LONG worksheet,LONG row,SHORT col,REAL number,LONG format),LONG,RAW,C,NAME('worksheet_write_number')
       worksheet_write_boolean(LONG worksheet,LONG row,SHORT col,SHORT value,LONG format),LONG,RAW,C,NAME('worksheet_write_boolean')
       worksheet_write_string(LONG worksheet,LONG row,SHORT col,*CSTRING string,LONG format),LONG,RAW,C,NAME('worksheet_write_string')
       worksheet_write_datetime(LONG worksheet,LONG row,SHORT col,*XLSX:DATETIME datetime,LONG format),LONG,RAW,C,NAME('worksheet_write_datetime')
       worksheet_write_blank(LONG worksheet,LONG row,SHORT col,LONG format),LONG,RAW,C,NAME('worksheet_write_blank')
       worksheet_write_url(LONG worksheet,LONG row,SHORT col,*CSTRING url,LONG format),LONG,RAW,C,NAME('worksheet_write_url')
       worksheet_write_formula(LONG worksheet,LONG row,SHORT col,*CSTRING formula,LONG format),LONG,RAW,C,NAME('worksheet_write_formula')
       worksheet_write_formula_num(LONG worksheet,LONG row,SHORT col,*CSTRING formula,LONG format,REAL result),LONG,RAW,C,NAME('worksheet_write_formula_num')
       worksheet_write_formula_str(LONG worksheet,LONG row,SHORT col,*CSTRING formula,LONG format,*CSTRING result),LONG,RAW,C,NAME('worksheet_write_formula_str')
       worksheet_write_array_formula(LONG worksheet,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col,*CSTRING formula,LONG format),LONG,RAW,C,NAME('worksheet_write_array_formula')
       worksheet_write_array_formula_num(LONG worksheet,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col,*CSTRING formula,LONG format,REAL result),LONG,RAW,C,NAME('worksheet_write_array_formula_num')
       worksheet_write_dynamic_formula(LONG worksheet,LONG row,SHORT col,*CSTRING formula,LONG format),LONG,RAW,C,NAME('worksheet_write_dynamic_formula')
       worksheet_write_dynamic_formula_num(LONG worksheet,LONG row,SHORT col,*CSTRING formula,LONG format,REAL result),LONG,RAW,C,NAME('worksheet_write_dynamic_formula_num')
       worksheet_write_dynamic_array_formula(LONG worksheet,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col,*CSTRING formula,LONG format),LONG,RAW,C,NAME('worksheet_write_dynamic_array_formula')
       worksheet_write_dynamic_array_formula_num(LONG worksheet,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col,*CSTRING formula,LONG format,REAL result),LONG,RAW,C,NAME('worksheet_write_array_dynamic_formula_num')
       worksheet_write_rich_string(LONG worksheet,LONG row,SHORT col,LONG rich_string_tuple,LONG format),LONG,RAW,C,NAME('worksheet_write_rich_string')
       worksheet_set_row(LONG worksheet,LONG row,REAL height,LONG format),LONG,RAW,C,NAME('worksheet_set_row')
       worksheet_set_row_opt(LONG worksheet,LONG row,REAL height,LONG format,*XLSX:rc_options options),LONG,RAW,C,NAME('worksheet_set_row_opt')
       worksheet_set_column(LONG worksheet,SHORT first_col,SHORT last_col,REAL width,LONG format),LONG,RAW,C,NAME('worksheet_set_column')
       worksheet_set_column_opt(LONG worksheet,SHORT first_col,SHORT last_col,REAL width,LONG format,*XLSX:rc_options options),LONG,RAW,C,NAME('worksheet_set_column_opt')
       worksheet_set_row_pixels(LONG worksheet,LONG row,LONG height,LONG format),LONG,RAW,C,NAME('worksheet_set_row_pixels')
       worksheet_set_row_pixels_opt(LONG worksheet,LONG row,LONG height,LONG format,*XLSX:rc_options options),LONG,RAW,C,NAME('worksheet_set_row_pixels_opt')
       worksheet_set_column_pixels(LONG worksheet,SHORT first_col,SHORT last_col,LONG width,LONG format),LONG,RAW,C,NAME('worksheet_set_column_pixels')
       worksheet_set_column_pixels_opt(LONG worksheet,SHORT first_col,SHORT last_col,LONG width,LONG format,*XLSX:rc_options options),LONG,RAW,C,NAME('worksheet_set_column_pixels_opt')
       worksheet_outline_settings(LONG worksheet,BYTE visible,BYTE symbols_below,BYTE symbols_right,BYTE auto_style),RAW,C,NAME('worksheet_outline_settings')

       worksheet_set_background(LONG worksheet,*CSTRING filename),LONG,RAW,C,NAME('worksheet_set_background')
       worksheet_set_background_buffer(LONG worksheet,*STRING image_buffer,ULONG image_size),LONG,RAW,C,NAME('worksheet_set_background_buffer')

       worksheet_insert_image(LONG worksheet,LONG row,SHORT col,*CSTRING filename),LONG,RAW,C,NAME('worksheet_insert_image')
       worksheet_insert_image_opt(LONG worksheet,LONG row,SHORT col,*CSTRING filename,*XLSX:IMAGEOPTIONS options),LONG,RAW,C,NAME('worksheet_insert_image_opt')

       worksheet_insert_image_buffer(LONG worksheet,LONG row,SHORT col,*STRING image_buffer,ULONG image_size),LONG,RAW,C,NAME('worksheet_insert_image_buffer')
       worksheet_insert_image_buffer_opt(LONG worksheet,LONG row,SHORT col,*STRING image_buffer,ULONG image_size,*XLSX:IMAGEOPTIONS options),LONG,RAW,C,NAME('worksheet_insert_image_buffer_opt')

       worksheet_insert_chart(LONG worksheet,LONG row,SHORT col,LONG chart),LONG,RAW,C,NAME('worksheet_insert_chart')
       worksheet_insert_chart_opt(LONG worksheet,LONG row,SHORT col,LONG chart,*XLSX:CHARTOPTIONS options),LONG,RAW,C,NAME('worksheet_insert_chart_opt')

       worksheet_insert_button(LONG worksheet,LONG row,SHORT col,*XLSX:button),LONG,RAW,C,NAME('worksheet_insert_button')

       worksheet_autofilter(LONG worksheet,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col),LONG,RAW,C,NAME('worksheet_autofilter')
       worksheet_filter_column(LONG worksheet,SHORT col,*XLSX:rule),LONG,RAW,C,NAME('worksheet_filter_column')
       worksheet_filter_column2(LONG worksheet,SHORT col,*XLSX:rule,*XLSX:rule,BYTE and_or),LONG,RAW,C,NAME('worksheet_filter_column2')
       worksheet_filter_list(LONG worksheet,SHORT col,LONG filter),LONG,RAW,C,NAME('worksheet_filter_list')
       worksheet_merge_range(LONG worksheet,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col,<*CSTRING string>,LONG format),LONG,RAW,C,NAME('worksheet_merge_range')
       worksheet_freeze_panes(LONG worksheet,LONG row,SHORT col),RAW,C,NAME('worksheet_freeze_panes')
       worksheet_split_panes(LONG worksheet,REAL vertical,REAL horizontal),RAW,C,NAME('worksheet_split_panes')
       worksheet_right_to_left(LONG worksheet),RAW,C,NAME('worksheet_right_to_left')
       worksheet_hide_zero(LONG worksheet),RAW,C,NAME('worksheet_hide_zero')
       worksheet_set_zoom(LONG worksheet,SHORT scale),RAW,C,NAME('worksheet_set_zoom')
       worksheet_gridlines(LONG worksheet,BYTE option),RAW,C,NAME('worksheet_gridlines')
       worksheet_set_selection(LONG worksheet,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col),RAW,C,NAME('worksheet_set_selection')
       worksheet_set_tab_color(LONG worksheet,LONG color),RAW,C,NAME('worksheet_set_tab_color')
       worksheet_set_default_row(LONG worksheet,REAL height,BYTE option),RAW,C,NAME('worksheet_set_default_row')
       worksheet_activate(LONG worksheet),RAW,C,NAME('worksheet_activate')
       worksheet_hide(LONG worksheet),RAW,C,NAME('worksheet_hide')
       worksheet_select(LONG worksheet),RAW,C,NAME('worksheet_select')
       worksheet_set_first_sheet(LONG worksheet),RAW,C,NAME('worksheet_set_first_sheet')
       worksheet_set_top_left_cell(LONG worksheet,LONG row,SHORT col),RAW,C,NAME('worksheet_set_top_left_cell')
       worksheet_set_vba_name(LONG worksheet,*CSTRING vbaname),LONG,RAW,C,NAME('worksheet_set_vba_name')

       worksheet_print_across(LONG worksheet),RAW,C,NAME('worksheet_print_across')
       worksheet_set_landscape(LONG worksheet),RAW,C,NAME('worksheet_set_landscape')
       worksheet_set_portrait(LONG worksheet),RAW,C,NAME('worksheet_set_portrait')
       worksheet_set_paper(LONG worksheet,BYTE paper_type),RAW,C,NAME('worksheet_set_paper')
       worksheet_center_horizontally(LONG worksheet),RAW,C,NAME('worksheet_center_horizontally')
       worksheet_center_vertically(LONG worksheet),RAW,C,NAME('worksheet_center_vertically')
       worksheet_set_page_view(LONG worksheet),RAW,C,NAME('worksheet_set_page_view')
       worksheet_print_row_col_headers(LONG worksheet),RAW,C,NAME('worksheet_print_row_col_headers')
       worksheet_print_area(LONG worksheet,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col),LONG,RAW,C,NAME('worksheet_print_area')
       worksheet_repeat_rows(LONG worksheet,LONG first_row,LONG last_row),LONG,RAW,C,NAME('worksheet_repeat_rows')
       worksheet_repeat_columns(LONG worksheet,SHORT first_col,SHORT last_col),LONG,RAW,C,NAME('worksheet_repeat_columns')
       worksheet_fit_to_pages(LONG worksheet,SHORT width,SHORT height),RAW,C,NAME('worksheet_fit_to_pages')
       worksheet_set_print_scale(LONG worksheet,SHORT scale),RAW,C,NAME('worksheet_set_print_scale')
       worksheet_set_start_page(LONG worksheet,SHORT start_page),RAW,C,NAME('worksheet_set_start_page')
       worksheet_set_margins(LONG worksheet,REAL m_left,REAL m_right,REAL m_top,REAL m_bottom),RAW,C,NAME('worksheet_set_margins')
       worksheet_set_h_pagebreaks(LONG worksheet,LONG),LONG,RAW,C,NAME('worksheet_set_h_pagebreaks')
       worksheet_set_v_pagebreaks(LONG worksheet,LONG),LONG,RAW,C,NAME('worksheet_set_v_pagebreaks')

       worksheet_set_header(LONG worksheet,*CSTRING string),LONG,RAW,C,NAME('worksheet_set_header')
       worksheet_set_footer(LONG worksheet,*CSTRING string),LONG,RAW,C,NAME('worksheet_set_footer')
       worksheet_set_header_opt(LONG worksheet,*CSTRING string,*XLSX:HF_OPTIONS options),LONG,RAW,C,NAME('worksheet_set_header_opt')
       worksheet_set_footer_opt(LONG worksheet,*CSTRING string,*XLSX:HF_OPTIONS options),LONG,RAW,C,NAME('worksheet_set_footer_opt')

       worksheet_data_validation_cell(LONG worksheet,LONG row,SHORT col,LONG validation),LONG,RAW,C,NAME('worksheet_data_validation_cell')
       worksheet_data_validation_range(LONG worksheet,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col,LONG validation),LONG,RAW,C,NAME('worksheet_data_validation_range')

       worksheet_conditional_format_cell(LONG worksheet,LONG row,SHORT col,LONG conditional_format),LONG,RAW,C,NAME('worksheet_conditional_format_cell')
       worksheet_conditional_format_range(LONG worksheet,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col,LONG validation),LONG,RAW,C,NAME('worksheet_conditional_format_range')

       worksheet_write_comment(LONG worksheet,LONG row,SHORT col,*CSTRING string),LONG,RAW,C,NAME('worksheet_write_comment')
       worksheet_write_comment_opt(LONG worksheet,LONG row,SHORT col,*CSTRING string,*XLSX:COMMENTOPTIONS options),LONG,RAW,C,NAME('worksheet_write_comment_opt')
       worksheet_set_comments_author(LONG worksheet,*CSTRING string),LONG,RAW,C,NAME('worksheet_set_comments_author')
       worksheet_show_comments(LONG worksheet),RAW,C,NAME('worksheet_show_comments')

       worksheet_protect(LONG worksheet,LONG password,LONG options),RAW,C,NAME('worksheet_protect')
       worksheet_ignore_errors(LONG worksheet,BYTE error_type,*CSTRING range),LONG,RAW,C,NAME('worksheet_ignore_errors')

       chartsheet_set_chart(LONG chartsheet,LONG chart),RAW,C,NAME('chartsheet_set_chart')
       chartsheet_activate(LONG chartsheet),RAW,C,NAME('chartsheet_activate')
       chartsheet_hide(LONG chartsheet),RAW,C,NAME('chartsheet_hide')
       chartsheet_select(LONG chartsheet),RAW,C,NAME('chartsheet_select')
       chartsheet_set_first_sheet(LONG chartsheet),RAW,C,NAME('chartsheet_set_first_sheet')
       chartsheet_set_tab_color(LONG chartsheet,LONG color),RAW,C,NAME('chartsheet_set_tab_color')
       chartsheet_set_landscape(LONG chartsheet),RAW,C,NAME('chartsheet_set_landscape')
       chartsheet_set_portrait(LONG chartsheet),RAW,C,NAME('chartsheet_set_portrait')
       chartsheet_set_paper(LONG chartsheet,BYTE paper_type),RAW,C,NAME('chartsheet_set_paper')
       chartsheet_set_zoom(LONG chartsheet,SHORT scale),RAW,C,NAME('chartsheet_set_zoom')
       chartsheet_set_margins(LONG chartsheet,REAL m_left,REAL m_right,REAL m_top,REAL m_bottom),RAW,C,NAME('chartsheet_set_margins')

       chartsheet_set_header(LONG chartsheet,*CSTRING string),LONG,RAW,C,NAME('chartsheet_set_header')
       chartsheet_set_footer(LONG chartsheet,*CSTRING string),LONG,RAW,C,NAME('chartsheet_set_footer')
       chartsheet_set_header_opt(LONG chartsheet,*CSTRING string,*XLSX:HF_OPTIONS options),LONG,RAW,C,NAME('chartsheet_set_header_opt')
       chartsheet_set_footer_opt(LONG chartsheet,*CSTRING string,*XLSX:HF_OPTIONS options),LONG,RAW,C,NAME('chartsheet_set_footer_opt')

       chartsheet_protect(LONG chartsheet,LONG password,LONG options),RAW,C,NAME('chartsheet_protect')

       format_set_font_size(LONG format,REAL font_size),RAW,C,NAME('format_set_font_size')
       format_set_font_name(LONG format,*CSTRING font_name),RAW,C,NAME('format_set_font_name')
       format_set_font_color(LONG format,LONG color),RAW,C,NAME('format_set_font_color')
       format_set_bold(LONG format),RAW,C,NAME('format_set_bold')
       format_set_italic(LONG format),RAW,C,NAME('format_set_italic')
       format_set_underline(LONG format,BYTE style),RAW,C,NAME('format_set_underline')
       format_set_font_strikeout(LONG format),RAW,C,NAME('format_set_font_strikeout')
       format_set_font_script(LONG format,BYTE style),RAW,C,NAME('format_set_font_script')

       format_set_num_format(LONG format,*CSTRING num_format),RAW,C,NAME('format_set_num_format')
       format_set_num_format_index(LONG format,BYTE index),RAW,C,NAME('format_set_num_format_index')
       format_set_align (LONG format,BYTE alignment),RAW,C,NAME('format_set_align')
       format_set_text_wrap(LONG format),RAW,C,NAME('format_set_text_wrap')
       format_set_rotation(LONG format,SHORT angle),RAW,C,NAME('format_set_rotation')
       format_set_indent(LONG format,BYTE level),RAW,C,NAME('format_set_indent')
       format_set_shrink(LONG format),RAW,C,NAME('format_set_shrink')

       format_set_pattern(LONG format,BYTE index),RAW,C,NAME('format_set_pattern')
       format_set_bg_color(LONG format,LONG color),RAW,C,NAME('format_set_bg_color')
       format_set_fg_color(LONG format,LONG color),RAW,C,NAME('format_set_fg_color')
       format_set_border(LONG format,BYTE style),RAW,C,NAME('format_set_border')
       format_set_bottom(LONG format,BYTE style),RAW,C,NAME('format_set_bottom')
       format_set_top(LONG format,BYTE style),RAW,C,NAME('format_set_top')
       format_set_left(LONG format,BYTE style),RAW,C,NAME('format_set_left')
       format_set_right(LONG format,BYTE style),RAW,C,NAME('format_set_right')
       format_set_border_color(LONG format,LONG color),RAW,C,NAME('format_set_border_color')
       format_set_bottom_color(LONG format,LONG color),RAW,C,NAME('format_set_bottom_color')
       format_set_top_color(LONG format,LONG color),RAW,C,NAME('format_set_top_color')
       format_set_left_color(LONG format,LONG color),RAW,C,NAME('format_set_left_color')
       format_set_right_color(LONG format,LONG color),RAW,C,NAME('format_set_right_color')

       format_set_diag_border(LONG format,BYTE style),RAW,C,NAME('format_set_diag_border')
       format_set_diag_type(LONG format,BYTE typ),RAW,C,NAME('format_set_diag_type')
       format_set_diag_color(LONG format,LONG color),RAW,C,NAME('format_set_diag_color')

       format_set_hidden(LONG format,BYTE hidden),RAW,C,NAME('format_set_hidden')
       format_set_unlocked(LONG format,BYTE unlocked),RAW,C,NAME('format_set_unlocked')

       lxw_strerror(LONG error_num),CSTRING,RAW,C,NAME('lxw_strerror')

       chart_add_series(LONG chart,LONG,LONG),LONG,RAW,C,NAME('chart_add_series')
       chart_series_set_categories(LONG series,*CSTRING sheetname,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col),RAW,C,NAME('chart_series_set_categories')
       chart_series_set_values(LONG series,*CSTRING sheetname,LONG first_row,SHORT first_col,LONG last_row,SHORT last_col),RAW,C,NAME('chart_series_set_values')
       chart_series_set_name(LONG series,*CSTRING name),RAW,C,NAME('chart_series_set_name')
       chart_series_set_name_range(LONG series,*CSTRING sheetname,LONG row,SHORT col),RAW,C,NAME('chart_series_set_name_range')
       chart_series_set_line(LONG series,*XLSX:chart_line_),RAW,C,NAME('chart_series_set_line')
       chart_series_set_fill(LONG series,*XLSX:chart_fill),RAW,C,NAME('chart_series_set_fill')
       chart_series_set_invert_if_negative(LONG series),RAW,C,NAME('chart_series_set_invert_if_negative')
       chart_series_set_pattern(LONG series,*XLSX:chart_pattern),RAW,C,NAME('chart_series_set_pattern')

       chart_series_set_marker_type(LONG series,BYTE type),RAW,C,NAME('chart_series_set_marker_type')
       chart_series_set_marker_size(LONG series,BYTE size),RAW,C,NAME('chart_series_set_marker_size')
       chart_series_set_marker_line(LONG series,*XLSX:chart_line_),RAW,C,NAME('chart_series_set_marker_line')
       chart_series_set_marker_fill(LONG series,*XLSX:chart_fill),RAW,C,NAME('chart_series_set_marker_fill')
       chart_series_set_marker_pattern(LONG series,*XLSX:chart_pattern),RAW,C,NAME('chart_series_set_marker_pattern')

       chart_series_set_points(LONG series,LONG points),LONG,RAW,C,NAME('chart_series_set_points')
       chart_series_set_labels_custom(LONG series,LONG labels),LONG,RAW,C,NAME('chart_series_set_labels_custom')

       chart_series_set_smooth(LONG series,BYTE smooth),RAW,C,NAME('chart_series_set_smooth')
       chart_series_set_labels(LONG series),RAW,C,NAME('chart_series_set_labels')
       chart_series_set_labels_options(LONG series,BYTE show_name,BYTE show_category,BYTE show_value),RAW,C,NAME('chart_series_set_labels_options')
       chart_series_set_labels_separator(LONG series,BYTE separator),RAW,C,NAME('chart_series_set_labels_separator')
       chart_series_set_labels_position(LONG series,BYTE position),RAW,C,NAME('chart_series_set_labels_position')
       chart_series_set_labels_leader_line(LONG series),RAW,C,NAME('chart_series_set_labels_leader_line')
       chart_series_set_labels_legend(LONG series),RAW,C,NAME('chart_series_set_labels_legend')
       chart_series_set_labels_percentage(LONG series),RAW,C,NAME('chart_series_set_labels_percentage')
       chart_series_set_labels_font(LONG series,*XLSX:chart_font),RAW,C,NAME('chart_series_set_labels_font')
       chart_series_set_labels_num_format(LONG series,*CSTRING num_format),RAW,C,NAME('chart_series_set_labels_num_format')
       chart_series_set_labels_line(LONG series,*XLSX:chart_line_),RAW,C,NAME('chart_series_set_labels_line')
       chart_series_set_labels_fill(LONG series,*XLSX:chart_fill),RAW,C,NAME('chart_series_set_labels_fill')
       chart_series_set_labels_pattern(LONG series,*XLSX:chart_pattern),RAW,C,NAME('chart_series_set_labels_pattern')

       chart_series_set_trendline(LONG series,BYTE type,BYTE value),RAW,C,NAME('chart_series_set_trendline')
       chart_series_set_trendline_forecast(LONG series,REAL forward,REAL backward),RAW,C,NAME('chart_series_set_trendline_forecast')
       chart_series_set_trendline_equation(LONG series),RAW,C,NAME('chart_series_set_trendline_equation')
       chart_series_set_trendline_r_squared(LONG series),RAW,C,NAME('chart_series_set_trendline_r_squared')
       chart_series_set_trendline_intercept(LONG series,REAL intercept),RAW,C,NAME('chart_series_set_trendline_intercept')
       chart_series_set_trendline_name(LONG series,*CSTRING name),RAW,C,NAME('chart_series_set_trendline_name')
       chart_series_set_trendline_line(LONG series,*XLSX:chart_line_),RAW,C,NAME('chart_series_set_trendline_line')

       chart_title_set_name(LONG chart,*CSTRING name),RAW,C,NAME('chart_title_set_name')
       chart_title_set_name_range(LONG chart,*CSTRING sheetname,LONG row,SHORT col),RAW,C,NAME('chart_title_set_name_range')
       chart_title_set_name_font(LONG chart,*XLSX:chart_font),RAW,C,NAME('chart_title_set_name_font')
       chart_title_off(LONG chart),RAW,C,NAME('chart_title_off')
       chart_legend_set_position(LONG chart,BYTE position),RAW,C,NAME('chart_legend_set_position')
       chart_legend_set_font(LONG chart,*XLSX:chart_font),RAW,C,NAME('chart_legend_set_font')
       chart_legend_delete_series(LONG chart,LONG),LONG,C,NAME('chart_legend_delete_series')
       chart_set_style(LONG chart,BYTE style_id),RAW,C,NAME('chart_set_style')
       chart_set_table(LONG chart),RAW,C,NAME('chart_set_table')
       chart_set_table_grid(LONG chart,BYTE horizontal,BYTE vertical,BYTE outline,BYTE legend_keys),RAW,C,NAME('chart_set_table_grid')

       chart_chartarea_set_line(LONG chart,*XLSX:chart_line_),RAW,C,NAME('chart_chartarea_set_line')
       chart_chartarea_set_fill(LONG chart,*XLSX:chart_fill),RAW,C,NAME('chart_chartarea_set_fill')
       chart_chartarea_set_pattern(LONG chart,*XLSX:chart_pattern),RAW,C,NAME('chart_chartarea_set_pattern')
       chart_plotarea_set_line(LONG chart,*XLSX:chart_line_),RAW,C,NAME('chart_plotarea_set_line')
       chart_plotarea_set_fill(LONG chart,*XLSX:chart_fill),RAW,C,NAME('chart_plotarea_set_fill')
       chart_plotarea_set_pattern(LONG chart,*XLSX:chart_pattern),RAW,C,NAME('chart_plotarea_set_pattern')

       chart_set_drop_lines(LONG chart,*XLSX:chart_line_),RAW,C,NAME('chart_set_drop_lines')
       chart_set_high_low_lines(LONG chart,*XLSX:chart_line_),RAW,C,NAME('chart_set_high_low_lines')

       chart_set_series_overlap(LONG chart,SHORT overlap),RAW,C,NAME('chart_set_series_overlap')
       chart_set_series_gap(LONG chart,USHORT gap),RAW,C,NAME('chart_set_series_gap')

       chart_set_rotation(LONG chart,USHORT rotation),RAW,C,NAME('chart_set_rotation')
       chart_set_hole_size(LONG chart,BYTE size),RAW,C,NAME('chart_set_hole_size')
       chart_show_blanks_as(LONG chart,BYTE option),RAW,C,NAME('chart_show_blanks_as')
       chart_show_hidden_data(LONG chart),RAW,C,NAME('chart_show_hidden_data')

       chart_axis_get(LONG chart,BYTE type),LONG,RAW,C,NAME('chart_axis_get')
       chart_axis_set_name(LONG axis,*CSTRING name),RAW,C,NAME('chart_axis_set_name')
       chart_axis_set_name_range(LONG axis,*CSTRING sheetname,LONG row,SHORT col),RAW,C,NAME('chart_axis_set_name_range')
       chart_axis_set_name_font(LONG axis,*XLSX:chart_font),RAW,C,NAME('chart_axis_set_name_font')
       chart_axis_set_num_format(LONG series,*CSTRING num_format),RAW,C,NAME('chart_axis_set_num_format')
       chart_axis_set_num_font(LONG axis,*XLSX:chart_font),RAW,C,NAME('chart_axis_set_num_font')
       chart_axis_set_line(LONG axis,*XLSX:chart_line_),RAW,C,NAME('chart_axis_set_line')
       chart_axis_set_fill(LONG axis,*XLSX:chart_fill),RAW,C,NAME('chart_axis_set_fill')
       chart_axis_set_pattern(LONG axis,*XLSX:chart_pattern),RAW,C,NAME('chart_axis_set_pattern')
       chart_axis_set_reverse(LONG axis),RAW,C,NAME('chart_axis_set_reverse')
       chart_axis_set_crossing(LONG axis,REAL value),RAW,C,NAME('chart_axis_set_crossing')
       chart_axis_set_crossing_max(LONG axis),RAW,C,NAME('chart_axis_set_crossing_max')
       chart_axis_set_crossing_min(LONG axis),RAW,C,NAME('chart_axis_set_crossing_min')
       chart_axis_off(LONG axis),RAW,C,NAME('chart_axis_off')
       chart_axis_set_position(LONG axis,BYTE position),RAW,C,NAME('chart_axis_set_position')
       chart_axis_set_label_position(LONG axis,BYTE position),RAW,C,NAME('chart_axis_set_label_position')
       chart_axis_set_label_align(LONG axis,BYTE align),RAW,C,NAME('chart_axis_set_label_align')
       chart_axis_set_min(LONG axis,REAL min),RAW,C,NAME('chart_axis_set_min')
       chart_axis_set_max(LONG axis,REAL max),RAW,C,NAME('chart_axis_set_max')
       chart_axis_set_log_base(LONG axis,SHORT log_base),RAW,C,NAME('chart_axis_set_log_base')
       chart_axis_set_major_tick_mark(LONG axis,BYTE type),RAW,C,NAME('chart_axis_set_major_tick_mark')
       chart_axis_set_minor_tick_mark(LONG axis,BYTE type),RAW,C,NAME('chart_axis_set_minor_tick_mark')
       chart_axis_set_interval_unit(LONG axis,SHORT unit),RAW,C,NAME('chart_axis_set_interval_unit')
       chart_axis_set_interval_tick(LONG axis,SHORT unit),RAW,C,NAME('chart_axis_set_interval_tick')
       chart_axis_set_major_unit(LONG axis,REAL unit),RAW,C,NAME('chart_axis_set_major_unit')
       chart_axis_set_minor_unit(LONG axis,REAL unit),RAW,C,NAME('chart_axis_set_minor_unit')
       chart_axis_set_display_units(LONG axis,BYTE units),RAW,C,NAME('chart_axis_set_display_units')
       chart_axis_set_display_units_visible(LONG axis,BYTE visible),RAW,C,NAME('chart_axis_set_display_units_visible')
       chart_axis_major_gridlines_set_visible(LONG axis,BYTE visible),RAW,C,NAME('chart_axis_major_gridlines_set_visible')
       chart_axis_minor_gridlines_set_visible(LONG axis,BYTE visible),RAW,C,NAME('chart_axis_minor_gridlines_set_visible')
       chart_axis_major_gridlines_set_line(LONG axis,*XLSX:chart_line_),RAW,C,NAME('chart_axis_major_gridlines_set_line')
       chart_axis_minor_gridlines_set_line(LONG axis,*XLSX:chart_line_),RAW,C,NAME('chart_axis_minor_gridlines_set_line')

       chart_series_get_error_bars(LONG axis,BYTE type),LONG,RAW,C,NAME('chart_series_get_error_bars')
       chart_series_set_error_bars(LONG error_bars,BYTE type,REAL value),RAW,C,NAME('chart_series_set_error_bars')
       chart_series_set_error_bars_direction(LONG error_bars,BYTE direction),RAW,C,NAME('chart_series_set_error_bars_direction')
       chart_series_set_error_bars_endcap(LONG error_bars,BYTE endcap),RAW,C,NAME('chart_series_set_error_bars_endcap')
       chart_series_set_error_bars_line(LONG error_bars,*XLSX:chart_line_),RAW,C,NAME('chart_series_set_error_bars_line')

       chart_set_up_down_bars(LONG chart),RAW,C,NAME('chart_set_up_down_bars')
       chart_set_up_down_bars_format(LONG chart,*XLSX:chart_line_,*XLSX:chart_fill,*XLSX:chart_line_,*XLSX:chart_fill),RAW,C,NAME('chart_set_up_down_bars_format')
     END

  END

xlsxwriter.Construct       PROCEDURE
  CODE
    Self.FormatQ &= NEW(XLSX:FormatQ)
    clear(Self.FormatQ)
    Self.RichStringTupleQ &= NEW(XLSX:RichStringTupleQ)
    clear(Self.RichStringTupleQ)
    Self.FilterQ &= NEW(XLSX:FilterQ)
    clear(Self.FilterQ)
COMPILE('***',_TPictureClassPresent_)
    Self.Picture &= NEW(TPictureClass)
***

xlsxwriter.Destruct        PROCEDURE
  CODE
    SELF.ClearFilterList
    dispose(Self.FilterQ)
    SELF.NewRichString
    dispose(Self.RichStringTupleQ)
    Free(Self.FormatQ)
    dispose(SELF.FormatQ)
COMPILE('***',_TPictureClassPresent_)
    dispose(Self.picture)
***
    if ~SELF.Cstr &= null
      dispose(SELF.Cstr)
    end

xlsxwriter.ToUTF8     PROCEDURE(STRING Str_In)
strInpChar  &CSTRING
strWideChar &CSTRING
lenWideChar long
lenMBChar   long
l           long

  CODE
    if ~SELF.Cstr &= null
      dispose(SELF.Cstr)
    end
    l = len(Str_In)
    if l=0
      SELF.Cstr &=NEW(CSTRING(1))
      return
    else
      loop
        a#=instring('<13,10>',Str_In,1,1)      ! lib does not support "\r\n" see Issue 156
        if a#=0 then break.
        if a#=1
          Str_In=Str_In[2 : l]
        else
          Str_In=Str_In[1 : a#-1] & Str_In[a#+1 : l]
        end
        l = len(Str_In)
      end
    end
    if SELF.UTF8
      SELF.Cstr &= new(CSTRING(len(Str_In)+1))
      SELF.Cstr = Str_In
    else
      strInpChar &= new(CSTRING(l + 1))
      strInpChar = Str_In
      strWideChar &= new(CSTRING(l*2+1))
      lenWideChar = XLSX:MultiByteToWideChar(0,0,address(strInpChar),-1,address(strWideChar),l*2)
      lenMBChar = XLSX:WideCharToMultiByte(65001,0,address(strWideChar),lenWideChar,0,0,0,0)
      SELF.Cstr &= new(CSTRING(lenMBChar))
      lenMBChar = XLSX:WideCharToMultiByte(65001,0,address(strWideChar),lenWideChar,address(SELF.Cstr),lenMBChar,0,0)
      dispose(strInpChar)
      dispose(strWideChar)
    end

xlsxwriter.NewWorkbook       PROCEDURE(STRING filename_,<BYTE constant_memory_>)
workbook_options GROUP
constant_memory    BYTE
padding1           BYTE
padding2           SHORT
tmpdir             LONG
use_zip64          BYTE
                 END
  CODE
    SELF.Filename=clip(filename_)
    if ~omitted(3)
      workbook_options.constant_memory=constant_memory_
      SELF.Workbook=workbook_new_opt(SELF.Filename,address(workbook_options))
    else
      SELF.Workbook=workbook_new(SELF.Filename)
    end
    free(SELF.FormatQ)
    clear(SELF.FormatQ)
    self.ClearFormat()
    SELF.ActiveSheet=0
    SELF.IsChartSheet=0

xlsxwriter.AddSheet      PROCEDURE(STRING sheetname_,<BYTE is_chartsheet_>)
  CODE
    SELF.ToUTF8(sheetname_)
    if is_chartsheet_
      SELF.ActiveSheet=workbook_add_chartsheet(SELF.Workbook,SELF.cstr)
      SELF.IsChartSheet=1
    else
      SELF.ActiveSheet=workbook_add_worksheet(SELF.Workbook,SELF.cstr)
      SELF.IsChartSheet=0
    end
    SELF.ActiveSheetName=SELF.cstr
    return SELF.ActiveSheet

xlsxwriter.CloseWorkbook     PROCEDURE()
  CODE
    a#=workbook_close(SELF.Workbook)
    SELF.Cstr &= null
    return a#

xlsxwriter.ReadOnlyRecommended     PROCEDURE()
  CODE
    workbook_read_only_recommended(SELF.Workbook)

xlsxwriter.SetProperties     PROCEDURE()
properties GROUP(XLSX:doc_properties)
 END
  CODE
    SELF.ToUTF8(Self.properties.title);          Self.properties.title=SELF.Cstr;          properties.title=address(Self.properties.title)
    SELF.ToUTF8(Self.properties.subject);        Self.properties.subject=SELF.Cstr;        properties.subject=address(Self.properties.subject)
    SELF.ToUTF8(Self.properties.author);         Self.properties.author=SELF.Cstr;         properties.author=address(Self.properties.author)
    SELF.ToUTF8(Self.properties.manager);        Self.properties.manager=SELF.Cstr;        properties.manager=address(Self.properties.manager)
    SELF.ToUTF8(Self.properties.company);        Self.properties.company=SELF.Cstr;        properties.company=address(Self.properties.company)
    SELF.ToUTF8(Self.properties.category);       Self.properties.category=SELF.Cstr;       properties.category=address(Self.properties.category)
    SELF.ToUTF8(Self.properties.keywords);       Self.properties.keywords=SELF.Cstr;       properties.keywords=address(Self.properties.keywords)
    SELF.ToUTF8(Self.properties.comments);       Self.properties.comments=SELF.Cstr;       properties.comments=address(Self.properties.comments)
    SELF.ToUTF8(Self.properties.status);         Self.properties.status=SELF.Cstr;         properties.status=address(Self.properties.status)
    SELF.ToUTF8(Self.properties.hyperlink_base); Self.properties.hyperlink_base=SELF.Cstr; properties.hyperlink_base=address(Self.properties.hyperlink_base)
    if Self.properties.created_date and Self.properties.created_time
      properties.created=(Self.properties.created_date-date(1,1,1970))*24*60*60+(Self.properties.created_time-1)/100
    end
    return workbook_set_properties(SELF.Workbook,properties)

xlsxwriter.SetCustomProperty PROCEDURE(STRING name_,<STRING string_>,<REAL number_>,<BYTE boolean_>,<LONG date_>)
cname  &CSTRING
dt      GROUP(XLSX:DATETIME)
 END
  CODE

    SELF.ToUTF8(name_)
    cname &=new(cstring(len(SELF.cstr)+1))
    cname = SELF.cstr

    if ~omitted(3)
      SELF.ToUTF8(string_)
      ret#=workbook_set_custom_property_string(SELF.Workbook,cname,SELF.cstr)
    end
    if ~omitted(4)
      ret#=workbook_set_custom_property_number(SELF.Workbook,cname,number_)
    end
    if ~omitted(5)
      ret#=workbook_set_custom_property_boolean(SELF.Workbook,cname,boolean_)
    end
    if ~omitted(6)
      XLSX:FormDateTime(dt,date_,0)
      ret#=workbook_set_custom_property_datetime(SELF.Workbook,cname,dt)
    end

    dispose(cname)
    return ret#

xlsxwriter.DefineName      PROCEDURE(STRING name_,STRING formula_)
cname  &CSTRING
  CODE
    SELF.ToUTF8(name_)
    cname &=new(cstring(len(SELF.cstr)+1))
    cname = SELF.cstr
    SELF.ToUTF8(formula_)
    ret#=workbook_define_name(SELF.Workbook,cname,SELF.cstr)
    dispose(cname)
    return ret#

xlsxwriter.ValidateSheetName      PROCEDURE(STRING Sheetname_)
  CODE
    SELF.ToUTF8(Sheetname_)
    return workbook_validate_sheet_name(SELF.Workbook,SELF.cstr)

xlsxwriter.AddVBAProject      PROCEDURE(STRING filename_)
filename   CSTRING(261)
  CODE
    filename=clip(filename_)
    return workbook_add_vba_project(SELF.Workbook,filename)

xlsxwriter.SetVBAName      PROCEDURE(STRING name_)
  CODE
    SELF.ToUTF8(name_)
    return workbook_set_vba_name(SELF.Workbook,SELF.cstr)

xlsxwriter.SetSheetVBAName      PROCEDURE(STRING name_)
  CODE
    SELF.ToUTF8(name_)
    return worksheet_set_vba_name(SELF.ActiveSheet,SELF.cstr)

xlsxwriter.GetSheetByName      PROCEDURE(STRING Sheetname_)
  CODE
    SELF.ToUTF8(Sheetname_)
    ret#=workbook_get_worksheet_by_name(SELF.Workbook,SELF.cstr)
    if ret#
      SELF.ActiveSheet=ret#
      SELF.ActiveSheetName=SELF.cstr
      SELF.IsChartsheet=0
    else
      ret#=workbook_get_chartsheet_by_name(SELF.Workbook,SELF.cstr)
      if ret#
        SELF.ActiveSheet=ret#
        SELF.ActiveSheetName=SELF.cstr
        SELF.IsChartsheet=1
      end
    end
    return ret#

xlsxwriter.GetDefaultURLFormat  PROCEDURE
  CODE
    SELF.ClearFormat()
    SELF.ActiveFormat=workbook_get_default_url_format(SELF.Workbook)

xlsxwriter.WriteNumber     PROCEDURE(LONG row_,SHORT col_,REAL number_)
  CODE
    return worksheet_write_number(SELF.ActiveSheet,row_-1,col_-1,number_,SELF.ActiveFormat)

xlsxwriter.WriteBoolean    PROCEDURE(LONG row_,SHORT col_,SHORT value_)
  CODE
    return worksheet_write_boolean(SELF.ActiveSheet,row_-1,col_-1,value_,SELF.ActiveFormat)

xlsxwriter.WriteString     PROCEDURE(LONG row_,SHORT col_,STRING string_)
  CODE
    SELF.ToUTF8(string_)
    return worksheet_write_string(SELF.ActiveSheet,row_-1,col_-1,SELF.cstr,SELF.ActiveFormat)

xlsxwriter.WriteUrl     PROCEDURE(LONG row_,SHORT col_,STRING url_,<STRING string_>)
  CODE
    SELF.ToUTF8(url_)
    ret# = worksheet_write_url(SELF.ActiveSheet,row_-1,col_-1,SELF.cstr,SELF.ActiveFormat)
    if ~omitted(5)
      if SELF.ActiveFormat=0
        SELF.GetDefaultURLFormat()
        ret#=SELF.WriteString(row_,col_,string_)
        SELF.ClearFormat()
      else
        ret#=SELF.WriteString(row_,col_,string_)
      end
    end
    return ret#

xlsxwriter.WriteFormula    PROCEDURE(LONG row_,SHORT col_,STRING formula_,<REAL result_>,<STRING result_str_>)
result_cstr  &CSTRING
  CODE
    if omitted(5) and omitted(6)
      SELF.ToUTF8(formula_)
      return worksheet_write_formula(SELF.ActiveSheet,row_-1,col_-1,SELF.cstr,SELF.ActiveFormat)
    elsif ~omitted(5)
      SELF.ToUTF8(formula_)
      return worksheet_write_formula_num(SELF.ActiveSheet,row_-1,col_-1,SELF.cstr,SELF.ActiveFormat,result_)
    elsif ~omitted(6)
      SELF.ToUTF8(result_str_)
      result_cstr &=new(cstring(len(SELF.cstr)+1))
      result_cstr = SELF.cstr
      SELF.ToUTF8(formula_)
      ret#=worksheet_write_formula_str(SELF.ActiveSheet,row_-1,col_-1,SELF.cstr,SELF.ActiveFormat,result_cstr)
      dispose(result_cstr)
    end

xlsxwriter.WriteArrayFormula    PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_,STRING formula_,<REAL result_>)
  CODE
    SELF.ToUTF8(formula_)
    if ~omitted(7)
      return worksheet_write_array_formula_num(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1,SELF.cstr,SELF.ActiveFormat,result_)
    else
      return worksheet_write_array_formula(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1,SELF.cstr,SELF.ActiveFormat)
    end

xlsxwriter.WriteDynamicFormula    PROCEDURE(LONG row_,SHORT col_,STRING formula_,<REAL result_>)
  CODE
    SELF.ToUTF8(formula_)
    if ~omitted(5)
      return worksheet_write_dynamic_formula_num(SELF.ActiveSheet,row_-1,col_-1,SELF.cstr,SELF.ActiveFormat,result_)
    else
      return worksheet_write_dynamic_formula(SELF.ActiveSheet,row_-1,col_-1,SELF.cstr,SELF.ActiveFormat)
    end

xlsxwriter.WriteDynamicArrayFormula    PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_,STRING formula_,<REAL result_>)
  CODE
    SELF.ToUTF8(formula_)
    if ~omitted(7)
      return worksheet_write_dynamic_array_formula_num(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1,SELF.cstr,SELF.ActiveFormat,result_)
    else
      return worksheet_write_dynamic_array_formula(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1,SELF.cstr,SELF.ActiveFormat)
    end

xlsxwriter.WriteBlank     PROCEDURE(LONG row_,SHORT col_)
  CODE
    return worksheet_write_blank(SELF.ActiveSheet,row_-1,col_-1,SELF.ActiveFormat)

xlsxwriter.WriteDateTime     PROCEDURE(LONG row_,SHORT col_,LONG date_,LONG time_)
dt      GROUP(XLSX:DATETIME)
 END
  CODE
    XLSX:FormDateTime(dt,date_,time_)
    return worksheet_write_datetime(SELF.ActiveSheet,row_-1,col_-1,dt,SELF.ActiveFormat)

xlsxwriter.WriteComment     PROCEDURE(LONG row_,SHORT col_,STRING string_,<BYTE visible_>,<STRING author_>,<SHORT width_>,<SHORT height_>,<REAL x_scale_>,<REAL y_scale_>,<LONG color_>,<STRING font_name_>,<REAL font_size_>,<BYTE font_family_>,<LONG start_row_>,<SHORT start_col_>,<LONG x_offset_>,<LONG y_offset_>)
font_name CSTRING(101)
author    CSTRING(256)
options  GROUP(XLSX:commentoptions)
         END
  CODE

    if ~omitted(5)
      options.visible=visible_
    end
    if ~omitted(6)
      SELF.ToUTF8(author_)
      author=SELF.cstr
      options.author=address(author)
    end
    if ~omitted(7)
      options.width=width_
    end
    if ~omitted(8)
      options.height=height_
    end
    if ~omitted(9)
      options.x_scale=x_scale_
    end
    if ~omitted(10)
      options.y_scale=y_scale_
    end
    if ~omitted(11)
      options.color=XLSX:RGBColor(color_)
    end
    if ~omitted(12)
      font_name=clip(font_name_)
      options.font_name=address(font_name)
    end
    if ~omitted(13)
      options.font_size=font_size_
    end
    if ~omitted(14)
      options.font_family=font_family_
    end
    if ~omitted(15)
      options.start_row=start_row_-1
    end
    if ~omitted(16)
      options.start_col=start_col_-1
    end
    if ~omitted(17)
      options.x_offset=x_offset_
    end
    if ~omitted(18)
      options.y_offset=y_offset_
    end
    SELF.ToUTF8(string_)
    return worksheet_write_comment_opt(SELF.ActiveSheet,row_-1,col_-1,SELF.cstr,options)

xlsxwriter.NewRichString    PROCEDURE
  CODE

  loop i#=1 to records(SELF.RichStringTupleQ)
    get(SELF.RichStringTupleQ,i#)
    if ~SELF.RichStringTupleQ.Cstr &= null
      dispose(SELF.RichStringTupleQ.Cstr)
    end
  end
  free(SELF.RichStringTupleQ)

xlsxwriter.AddToRichString    PROCEDURE(STRING str_,LONG format_)
  CODE

  if str_<>''
    SELF.ToUTF8(str_)
    clear(SELF.RichStringTupleQ)
    SELF.RichStringTupleQ.Cstr &= NEW(cstring(len(SELF.cstr)+1))
    SELF.RichStringTupleQ.Cstr = SELF.cstr
    SELF.RichStringTupleQ.Format = format_
    add(SELF.RichStringTupleQ)
  end

xlsxwriter.WriteRichStrings    PROCEDURE(LONG row_,SHORT col_,LONG records_)
rich_string_tupled LONG,DIM(records_+1)
rich_string_tuple  LONG,DIM(records_*2)
  CODE
    loop i#=1 to records_
      get(SELF.RichStringTupleQ,i#)
      rich_string_tuple[i#*2-1]    = SELF.RichStringTupleQ.Format
      rich_string_tuple[i#*2]      = address(SELF.RichStringTupleQ.Cstr)
      rich_string_tupled[i#]       = address(rich_string_tuple[i#*2-1])
    end

    return worksheet_write_rich_string(SELF.ActiveSheet,row_-1,col_-1,address(rich_string_tupled),SELF.ActiveFormat)

xlsxwriter.WriteRichString    PROCEDURE(LONG row_,SHORT col_)
  CODE
    if records(SELF.RichStringTupleQ)>1
      return SELF.WriteRichStrings(row_,col_,records(SELF.RichStringTupleQ))
    end

xlsxwriter.Merge     PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_,<STRING string_>)
  CODE
    if omitted(6)
      return worksheet_merge_range(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1,,SELF.ActiveFormat)
    elsif first_row_=last_row_ and first_col_=last_col_
      return SELF.WriteString(first_row_,first_col_,string_)
    else
      SELF.ToUTF8(string_)
      return worksheet_merge_range(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1,SELF.cstr,SELF.ActiveFormat)
    end

xlsxwriter.Autofilter     PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_)
  CODE
    return worksheet_autofilter(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1)

xlsxwriter.FilterColumn   PROCEDURE(SHORT col_,BYTE criteria_,<STRING value_str_>,<REAL value_>,<BYTE criteria2_>,<STRING value_str2_>,<REAL value2_>,<BYTE and_or_>)
rule1   GROUP(XLSX:rule)
        END
rule2   GROUP(XLSX:rule)
        END
cstr1   &CSTRING
cstr2   &CSTRING
and_or  BYTE
  CODE
    rule1.criteria=criteria_
    if ~omitted(4)
      SELF.ToUTF8(value_str_)
      cstr1 &=new(cstring(len(SELF.cstr)+1))
      cstr1 = SELF.cstr
      rule1.value_string=address(cstr1)
    end
    if ~omitted(5)
      rule1.value=value_
    end
    if ~omitted(6)
      rule2.criteria=criteria2_
    end
    if ~omitted(7)
      SELF.ToUTF8(value_str2_)
      cstr2 &=new(cstring(len(SELF.cstr)+1))
      cstr2 = SELF.cstr
      rule2.value_string=address(cstr2)
    end
    if ~omitted(8)
      rule2.value=value2_
    end
    if ~omitted(9)
      and_or=and_or_
    end
    if ~omitted(6)
      ret#=worksheet_filter_column2(SELF.ActiveSheet,col_-1,rule1,rule2,and_or)
    else
      ret#=worksheet_filter_column(SELF.ActiveSheet,col_-1,rule1)
    end
    if ~cstr1 &= null then dispose(cstr1).
    if ~cstr2 &= null then dispose(cstr2).
    return ret#

xlsxwriter.AddToFilterList    PROCEDURE(STRING str_)
  CODE

  if str_<>''
    SELF.ToUTF8(str_)
    SELF.FilterQ.Cstr &= NEW(cstring(len(SELF.cstr)+1))
    SELF.FilterQ.Cstr = SELF.cstr
    add(SELF.FilterQ)
  end

xlsxwriter.ClearFilterList    PROCEDURE
  CODE

  loop i#=1 to records(SELF.FilterQ)
    get(SELF.FilterQ,i#)
    if ~SELF.FilterQ.Cstr &= null
      dispose(SELF.FilterQ.Cstr)
    end
  end
  free(SELF.FilterQ)

xlsxwriter.WriteFilter    PROCEDURE(SHORT col_,LONG records_)
filterd LONG,DIM(records_+1)
  CODE
    loop i#=1 to records_
      get(SELF.FilterQ,i#)
      filterd[i#]      = address(SELF.FilterQ.Cstr)
    end
    ret#=worksheet_filter_list(SELF.ActiveSheet,col_-1,address(filterd))
    return ret#

xlsxwriter.FilterList    PROCEDURE(SHORT col_)
  CODE
    if records(SELF.FilterQ)>0
      return SELF.WriteFilter(col_,records(SELF.FilterQ))
    end

xlsxwriter.SetSelection     PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_)
  CODE
    worksheet_set_selection(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1)

xlsxwriter.SetColumn      PROCEDURE(SHORT first_col_,SHORT last_col_,REAL width_,<BYTE hidden_>,<BYTE level_>,<BYTE collapsed_>)
options  GROUP(XLSX:rc_options)
         END

  CODE
    if omitted(5) and omitted(6) and omitted(7)
      return worksheet_set_column(SELF.ActiveSheet,first_col_-1,last_col_-1,width_,SELF.ActiveFormat)
    else
      if ~omitted(5)
        options.hidden=hidden_
      end
      if ~omitted(6)
        options.level=level_
      end
      if ~omitted(7)
        options.collapsed=collapsed_
      end
      return worksheet_set_column_opt(SELF.ActiveSheet,first_col_-1,last_col_-1,width_,SELF.ActiveFormat,options)
    end

xlsxwriter.SetRow      PROCEDURE(LONG row_,REAL height_,<BYTE hidden_>,<BYTE level_>,<BYTE collapsed_>)
options  GROUP(XLSX:rc_options)
         END

  CODE
    if omitted(4) and omitted(5) and omitted(6)
      return worksheet_set_row(SELF.ActiveSheet,row_-1,height_,SELF.ActiveFormat)
    else
      if ~omitted(4)
        options.hidden=hidden_
      end
      if ~omitted(5)
        options.level=level_
      end
      if ~omitted(6)
        options.collapsed=collapsed_
      end
      options.hidden=hidden_
      return worksheet_set_row_opt(SELF.ActiveSheet,row_-1,height_,SELF.ActiveFormat,options)
    end

xlsxwriter.SetColumnPixels      PROCEDURE(SHORT first_col_,SHORT last_col_,LONG width_,<BYTE hidden_>,<BYTE level_>,<BYTE collapsed_>)
options  GROUP(XLSX:rc_options)
         END

  CODE
    if omitted(5) and omitted(6) and omitted(7)
      return worksheet_set_column(SELF.ActiveSheet,first_col_-1,last_col_-1,width_,SELF.ActiveFormat)
    else
      if ~omitted(5)
        options.hidden=hidden_
      end
      if ~omitted(6)
        options.level=level_
      end
      if ~omitted(7)
        options.collapsed=collapsed_
      end
      return worksheet_set_column_pixels_opt(SELF.ActiveSheet,first_col_-1,last_col_-1,width_,SELF.ActiveFormat,options)
    end

xlsxwriter.SetRowPixels      PROCEDURE(LONG row_,LONG height_,<BYTE hidden_>,<BYTE level_>,<BYTE collapsed_>)
options  GROUP(XLSX:rc_options)
         END

  CODE
    if omitted(4) and omitted(5) and omitted(6)
      return worksheet_set_row(SELF.ActiveSheet,row_-1,height_,SELF.ActiveFormat)
    else
      if ~omitted(4)
        options.hidden=hidden_
      end
      if ~omitted(5)
        options.level=level_
      end
      if ~omitted(6)
        options.collapsed=collapsed_
      end
      options.hidden=hidden_
      return worksheet_set_row_pixels_opt(SELF.ActiveSheet,row_-1,height_,SELF.ActiveFormat,options)
    end

xlsxwriter.OutlineSettings      PROCEDURE(BYTE visible_,BYTE symbols_below_,BYTE symbols_right_,BYTE auto_style_)
  CODE
    worksheet_outline_settings(SELF.ActiveSheet,visible_,symbols_below_,symbols_right_,auto_style_)

xlsxwriter.ClearFormat PROCEDURE
  CODE
    SELF.ActiveFormat=0
    clear(SELF.Format)
    SELF.Format.Color=COLOR:NONE
    SELF.Format.FGColor=COLOR:NONE
    SELF.Format.FontColor=COLOR:NONE
    SELF.Format.Border.Color=COLOR:NONE
    SELF.Format.Top.Color=COLOR:NONE
    SELF.Format.Bottom.Color=COLOR:NONE
    SELF.Format.Right.Color=COLOR:NONE
    SELF.Format.Left.Color=COLOR:NONE
    SELF.Format.Diag.Color=COLOR:NONE
    SELF.Format.Border.Format=XLSX:NoBorder
    SELF.Format.Top.Format=XLSX:NoBorder
    SELF.Format.Bottom.Format=XLSX:NoBorder
    SELF.Format.Right.Format=XLSX:NoBorder
    SELF.Format.Left.Format=XLSX:NoBorder
    SELF.Format.Diag.Format=XLSX:NoBorder

xlsxwriter.SetFormat PROCEDURE(BYTE Active_=1)

  CODE
    SELF.FormatQ.FormatG=SELF.Format
    get(SELF.FormatQ,SELF.FormatQ.FormatG)
    if errorcode()
      SELF.FormatQ.FormatG=SELF.Format
      SELF.FormatQ.Ref=workbook_add_format(SELF.workbook)
      add(SELF.FormatQ)

      COMPILE('***',_TPictureClassPresent_)

      if clip(SELF.Format.Picture)<>'' and lower(sub(left(SELF.Format.Picture),1,2))<>'@s'
        pic#=SELF.Picture.TakePicture(SELF.Format.Picture)
        SELF.Format.ExcelMask=SELF.Picture.ExcelMask
      end

      ***

      if clip(SELF.Format.ExcelMask)<>''
        SELF.ToUTF8(SELF.Format.ExcelMask)
        format_set_num_format(SELF.FormatQ.Ref,SELF.Cstr)
      end

      if SELF.Format.Index
        format_set_num_format_index(SELF.FormatQ.Ref,SELF.Format.Index)
      end

      if SELF.Format.Border.Format<>XLSX:NoBorder
        format_set_border(SELF.FormatQ.Ref,SELF.Format.Border.Format)
      end
      if SELF.Format.Left.Format<>XLSX:NoBorder
        format_set_left(SELF.FormatQ.Ref,SELF.Format.Left.Format)
      end
      if SELF.Format.Right.Format<>XLSX:NoBorder
        format_set_right(SELF.FormatQ.Ref,SELF.Format.Right.Format)
      end
      if SELF.Format.Top.Format<>XLSX:NoBorder
        format_set_top(SELF.FormatQ.Ref,SELF.Format.Top.Format)
      end
      if SELF.Format.Bottom.Format<>XLSX:NoBorder
        format_set_bottom(SELF.FormatQ.Ref,SELF.Format.Bottom.Format)
      end
      if SELF.Format.Diag.Format<>XLSX:NoBorder
        format_set_diag_border(SELF.FormatQ.Ref,SELF.Format.Diag.Format)
      end

      if SELF.Format.Border.Color<>COLOR:NONE
        format_set_border_color(SELF.FormatQ.Ref,XLSX:RGBColor(SELF.Format.Border.Color))
      end
      if SELF.Format.Left.Color<>COLOR:NONE
        format_set_left_color(SELF.FormatQ.Ref,XLSX:RGBColor(SELF.Format.Left.Color))
      end
      if SELF.Format.Right.Color<>COLOR:NONE
        format_set_right_color(SELF.FormatQ.Ref,XLSX:RGBColor(SELF.Format.Right.Color))
      end
      if SELF.Format.Top.Color<>COLOR:NONE
        format_set_top_color(SELF.FormatQ.Ref,XLSX:RGBColor(SELF.Format.Top.Color))
      end
      if SELF.Format.Bottom.Color<>COLOR:NONE
        format_set_bottom_color(SELF.FormatQ.Ref,XLSX:RGBColor(SELF.Format.Bottom.Color))
      end
      if SELF.Format.Diag.Color<>COLOR:NONE
        format_set_diag_color(SELF.FormatQ.Ref,XLSX:RGBColor(SELF.Format.Diag.Color))
      end

      if SELF.Format.Diag.Type
        format_set_diag_type(SELF.FormatQ.Ref,SELF.Format.Diag.Type)
      end

      if SELF.Format.Color<>COLOR:NONE
        format_set_bg_color(SELF.FormatQ.Ref,XLSX:RGBColor(SELF.Format.Color))
      end

      if SELF.Format.FGColor<>COLOR:NONE
        format_set_fg_color(SELF.FormatQ.Ref,XLSX:RGBColor(SELF.Format.FGColor))
      end

      if SELF.Format.FontColor<>COLOR:NONE
        format_set_Font_color(SELF.FormatQ.Ref,XLSX:RGBColor(SELF.Format.FontColor))
      end

      if SELF.Format.FontSize
        format_set_font_size(SELF.FormatQ.Ref,SELF.Format.FontSize)
      end
      if SELF.Format.FontName<>''
        format_set_font_name(SELF.FormatQ.Ref,SELF.Format.FontName)
      end
      if BAND(SELF.Format.FontStyle,font:Bold)=font:Bold
        format_set_bold(SELF.FormatQ.Ref)
      end
      if BAND(SELF.Format.FontStyle,font:Italic)=font:Italic
        format_set_italic(SELF.FormatQ.Ref)
      end
      if BAND(SELF.Format.FontStyle,font:UnderLine)=font:UnderLine
        format_set_underline(SELF.FormatQ.Ref,choose(SELF.Format.Underline>0,SELF.Format.Underline,1))
      end
      if BAND(SELF.Format.FontStyle,font:Strikeout)=font:Strikeout
        format_set_font_strikeout(SELF.FormatQ.Ref)  
      end
      if SELF.Format.FontScript
        format_set_font_script(SELF.FormatQ.Ref,SELF.Format.FontScript)
      end
      if SELF.Format.Align
        format_set_align(SELF.FormatQ.Ref,SELF.Format.Align)
      end
      if SELF.Format.AlignV
        format_set_align(SELF.FormatQ.Ref,SELF.Format.AlignV)
      end
      if SELF.Format.WrapText
        format_set_text_wrap(SELF.FormatQ.Ref)
      end
      if SELF.Format.Rotation
        format_set_rotation(SELF.FormatQ.Ref,SELF.Format.Rotation)
      end
      if SELF.Format.Indent
        format_set_indent(SELF.FormatQ.Ref,SELF.Format.Indent)
      end
      if SELF.Format.Shrink
        format_set_shrink(SELF.FormatQ.Ref)
      end
      if SELF.Format.Pattern
        format_set_pattern(SELF.FormatQ.Ref,SELF.Format.Pattern)
      end

      if SELF.Format.Hidden
        format_set_hidden(SELF.FormatQ.Ref,SELF.Format.Hidden)
      end
      if SELF.Format.Unlocked
        format_set_unlocked(SELF.FormatQ.Ref,SELF.Format.Unlocked)
      end

    end
    if Active_
      SELF.ActiveFormat=SELF.FormatQ.Ref
    end
    return SELF.FormatQ.Ref

xlsxwriter.SetZoom      PROCEDURE(SHORT Scale_)
  CODE
    if SELF.IsChartsheet
      chartsheet_set_zoom(SELF.ActiveSheet,scale_)
    else
      worksheet_set_zoom(SELF.ActiveSheet,scale_)
    end

xlsxwriter.Gridlines      PROCEDURE(BYTE Option_)
  CODE
    worksheet_gridlines(SELF.ActiveSheet,option_)

xlsxwriter.HideZero      PROCEDURE()
  CODE
    worksheet_hide_zero(SELF.ActiveSheet)

xlsxwriter.RightToLeft      PROCEDURE()
  CODE
    worksheet_right_to_left(SELF.ActiveSheet)

xlsxwriter.Activate      PROCEDURE()
  CODE
    if SELF.IsChartsheet
      chartsheet_activate(SELF.ActiveSheet)
    else
      worksheet_activate(SELF.ActiveSheet)
    end

xlsxwriter.Select      PROCEDURE()
  CODE
    if SELF.IsChartsheet
      chartsheet_select(SELF.ActiveSheet)
    else
      worksheet_select(SELF.ActiveSheet)
    end

xlsxwriter.Hide      PROCEDURE()
  CODE
    if SELF.IsChartsheet
      chartsheet_hide(SELF.ActiveSheet)
    else
      worksheet_hide(SELF.ActiveSheet)
    end

xlsxwriter.SetFirstSheet      PROCEDURE()
  CODE
    if SELF.IsChartsheet
      chartsheet_set_first_sheet(SELF.ActiveSheet)
    else
      worksheet_set_first_sheet(SELF.ActiveSheet)
    end

xlsxwriter.SetTopLeftCell    PROCEDURE(LONG row_,SHORT col_)
  CODE
    worksheet_set_top_left_cell(SELF.ActiveSheet,row_-1,col_-1)

xlsxwriter.ShowComments      PROCEDURE()
  CODE
    worksheet_show_comments(SELF.ActiveSheet)

xlsxwriter.SetChart      PROCEDURE(LONG chart_)
  CODE
    chartsheet_set_chart(SELF.ActiveSheet,chart_)

xlsxwriter.FreezePanes      PROCEDURE(LONG row_,SHORT col_)
  CODE
    worksheet_freeze_panes(SELF.ActiveSheet,row_-1,col_-1)

xlsxwriter.SplitPanes      PROCEDURE(REAL vertical_,REAL horizontal_)
  CODE
    worksheet_split_panes(SELF.ActiveSheet,vertical_,horizontal_)

xlsxwriter.SetBackground      PROCEDURE(STRING filename_)
filename   CSTRING(261)

  CODE
    filename=clip(filename_)
    ret#=worksheet_set_background(SELF.ActiveSheet,filename)
    return ret#

xlsxwriter.SetBackgroundBuffer      PROCEDURE(*STRING image_,ULONG image_size_)
  CODE
    ret#=worksheet_set_background_buffer(SELF.ActiveSheet,image_,image_size_)
    return ret#

xlsxwriter.InsertImage      PROCEDURE(LONG row_,SHORT col_,STRING filename_,<LONG x_offset_>,<LONG y_offset_>,<REAL x_scale_>,<REAL y_scale_>,<BYTE object_position_>,<STRING description_>,<BYTE decorative_>,<STRING url_>,<STRING tip_>)
options   GROUP(XLSX:IMAGEOPTIONS)
  END
filename   CSTRING(261)
curl_      &CSTRING
ctip_      &CSTRING

  CODE
    filename=clip(filename_)
    if ~omitted(5)
      options.x_offset=x_offset_
    end
    if ~omitted(6)
      options.y_offset=y_offset_
    end
    if ~omitted(7)
      options.x_scale=x_scale_
    else                                                                        
      options.x_scale=1
    end
    if ~omitted(8)
      options.y_scale=y_scale_
    else
      options.y_scale=1
    end
    if ~omitted(9)
      options.object_position=object_position_
    end
    if ~omitted(11)
      options.decorative=decorative_
    end
    if ~omitted(12) and clip(url_)<>''
      SELF.ToUTF8(url_)
      curl_ &=new(cstring(len(SELF.cstr)+1))
      curl_ = SELF.cstr
      options.url = address(curl_)
    end
    if ~omitted(13) and clip(tip_)<>''
      SELF.ToUTF8(tip_)
      ctip_ &=new(cstring(len(SELF.cstr)+1))
      ctip_ = SELF.cstr
      options.tip = address(ctip_)
    end
    if ~omitted(10)
      SELF.ToUTF8(description_)
    else
      slash#=instring('\',filename_,-1,len(filename_))
      if slash# and slash#<len(filename_)
        SELF.ToUTF8(filename_[slash#+1 : len(filename_)])
      else
        SELF.ToUTF8(filename_)
      end
    end
    options.description=address(SELF.Cstr)

    ret#=worksheet_insert_image_opt(SELF.ActiveSheet,row_-1,col_-1,filename,options)

    if ~curl_ &= null then dispose(curl_).
    if ~ctip_ &= null then dispose(ctip_).
    return ret#

xlsxwriter.InsertImageBuffer      PROCEDURE(LONG row_,SHORT col_,*STRING image_,ULONG image_size_,<LONG x_offset_>,<LONG y_offset_>,<REAL x_scale_>,<REAL y_scale_>,<BYTE object_position_>,<STRING description_>,<BYTE decorative_>,<STRING url_>,<STRING tip_>)
options   GROUP(XLSX:IMAGEOPTIONS)
  END
curl_      &CSTRING
ctip_      &CSTRING

  CODE
    if ~omitted(6)
      options.x_offset=x_offset_
    end
    if ~omitted(7)
      options.y_offset=y_offset_
    end
    if ~omitted(8)
      options.x_scale=x_scale_
    else                                                                        
      options.x_scale=1
    end
    if ~omitted(9)
      options.y_scale=y_scale_
    else
      options.y_scale=1
    end
    if ~omitted(10)
      options.object_position=object_position_
    end
    if ~omitted(12)
      options.decorative=decorative_
    end
    if ~omitted(13) and clip(url_)<>''
      SELF.ToUTF8(url_)
      curl_ &=new(cstring(len(SELF.cstr)+1))
      curl_ = SELF.cstr
      options.url = address(curl_)
    end
    if ~omitted(14) and clip(tip_)<>''
      SELF.ToUTF8(tip_)
      ctip_ &=new(cstring(len(SELF.cstr)+1))
      ctip_ = SELF.cstr
      options.tip = address(ctip_)
    end
    if ~omitted(11)
      SELF.ToUTF8(description_)
      options.description=address(SELF.Cstr)
    end

    ret#=worksheet_insert_image_buffer_opt(SELF.ActiveSheet,row_-1,col_-1,image_,image_size_,options)

    if ~curl_ &= null then dispose(curl_).
    if ~ctip_ &= null then dispose(ctip_).
    return ret#

xlsxwriter.InsertChart      PROCEDURE(LONG row_,SHORT col_,LONG chart_,<LONG x_offset_>,<LONG y_offset_>,<REAL x_scale_>,<REAL y_scale_>,<BYTE object_position_>,<STRING description_>,<BYTE decorative_>)
options   GROUP(XLSX:CHARTOPTIONS)
  END

  CODE
    if omitted(5) and omitted(6) and omitted(7) and omitted(8) and omitted(9) and omitted(10) and omitted(11)
      ret#=worksheet_insert_chart(SELF.ActiveSheet,row_-1,col_-1,chart_)
    else
      if ~omitted(5)
        options.x_offset=x_offset_
      end
      if ~omitted(6)
        options.y_offset=y_offset_
      end
      if ~omitted(7)
        options.x_scale=x_scale_
      else                                                                        
        options.x_scale=1
      end
      if ~omitted(8)
        options.y_scale=y_scale_
      else
        options.y_scale=1
      end
      if ~omitted(9)
        options.object_position=object_position_
      end
      if ~omitted(10)
        SELF.ToUTF8(description_)
        options.description=address(SELF.Cstr)
      end
      if ~omitted(11)
        options.decorative=decorative_
      end
      ret#=worksheet_insert_chart_opt(SELF.ActiveSheet,row_-1,col_-1,chart_,options)
    end
    return ret#

xlsxwriter.InsertButton      PROCEDURE(LONG row_,SHORT col_,<STRING caption_>,<STRING macro_>,<STRING description_>,<USHORT width_>,<USHORT height_>,<REAL x_scale_>,<REAL y_scale_>,<LONG x_offset_>,<LONG y_offset_>)
options   GROUP(XLSX:BUTTON)
  END
ccaption_     &CSTRING
cmacro_       &CSTRING
cdescription_ &CSTRING

  CODE
    if ~omitted(4)
      SELF.ToUTF8(caption_)
      ccaption_ &=new(cstring(len(SELF.cstr)+1))
      ccaption_ = SELF.cstr
      options.caption = address(ccaption_)
    end
    if ~omitted(5)
      SELF.ToUTF8(macro_)
      cmacro_ &=new(cstring(len(SELF.cstr)+1))
      cmacro_ = SELF.cstr
      options.macro = address(cmacro_)
    end
    if ~omitted(6)
      SELF.ToUTF8(description_)
      cdescription_ &=new(cstring(len(SELF.cstr)+1))
      cdescription_ = SELF.cstr
      options.description = address(cdescription_)
    end
    if ~omitted(7)
      options.width=width_
    end
    if ~omitted(8)
      options.height=height_
    end
    if ~omitted(9)
      options.x_scale=x_scale_
    else                                                                        
      options.x_scale=1
    end
    if ~omitted(10)
      options.y_scale=y_scale_
    else
      options.y_scale=1
    end
    if ~omitted(11)
      options.x_offset=x_offset_
    end
    if ~omitted(12)
      options.y_offset=y_offset_
    end
    ret#=worksheet_insert_button(SELF.ActiveSheet,row_-1,col_-1,options)

    if ~ccaption_ &= null then dispose(ccaption_).
    if ~cmacro_ &= null then dispose(cmacro_).
    if ~cdescription_ &= null then dispose(cdescription_).
    return ret#

xlsxwriter.PrintAcross            PROCEDURE()
  CODE
  worksheet_print_across(SELF.ActiveSheet)

xlsxwriter.PrintRowColHeaders     PROCEDURE()
  CODE
  worksheet_print_row_col_headers(SELF.ActiveSheet)

xlsxwriter.PrintArea     PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_)
  CODE
    return worksheet_print_area(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1)

xlsxwriter.RepeatRows     PROCEDURE(LONG first_row_,LONG last_row_)
  CODE
    return worksheet_repeat_rows(SELF.ActiveSheet,first_row_-1,last_row_-1)

xlsxwriter.RepeatColumns     PROCEDURE(SHORT first_col_,SHORT last_col_)
  CODE
    return worksheet_repeat_columns(SELF.ActiveSheet,first_col_-1,last_col_-1)

xlsxwriter.FitToPages     PROCEDURE(SHORT width_,SHORT height_)
  CODE
    worksheet_fit_to_pages(SELF.ActiveSheet,width_,height_)

xlsxwriter.AddPagebreakV   PROCEDURE(SHORT col_)
  CODE
    loop i#=1 to maximum(SELF.BreaksV,1)
      if SELF.BreaksV[i#]=col_-1 then break.
      if SELF.BreaksV[i#]=0
        SELF.BreaksV[i#]=col_-1
        break
      end
    end

xlsxwriter.AddPagebreakH   PROCEDURE(LONG row_)
  CODE
    loop i#=1 to maximum(SELF.BreaksH,1)
      if SELF.BreaksH[i#]=row_-1 then break.
      if SELF.BreaksH[i#]=0
        SELF.BreaksH[i#]=row_-1
        break
      end
    end

xlsxwriter.SetPagebreaksV  PROCEDURE()
  CODE
    return worksheet_set_v_pagebreaks(SELF.ActiveSheet,address(SELF.BreaksV))

xlsxwriter.SetPagebreaksH  PROCEDURE()
  CODE
    return worksheet_set_h_pagebreaks(SELF.ActiveSheet,address(SELF.BreaksH))

xlsxwriter.SetTabColor     PROCEDURE(LONG color_)
  CODE
    if SELF.IsChartsheet
      chartsheet_set_tab_color(SELF.ActiveSheet,XLSX:RGBColor(color_))
    else
      worksheet_set_tab_color(SELF.ActiveSheet,XLSX:RGBColor(color_))
    end

xlsxwriter.SetLandscape            PROCEDURE()
  CODE
    if SELF.IsChartsheet
      chartsheet_set_landscape(SELF.ActiveSheet)
    else
      worksheet_set_landscape(SELF.ActiveSheet)
    end

xlsxwriter.SetPortrait             PROCEDURE()
  CODE
    if SELF.IsChartsheet
      chartsheet_set_portrait(SELF.ActiveSheet)
    else
      worksheet_set_portrait(SELF.ActiveSheet)
    end

xlsxwriter.SetPaper                PROCEDURE(BYTE paper_type_)
  CODE
    if SELF.IsChartsheet
      chartsheet_set_paper(SELF.ActiveSheet,paper_type_)
    else
      worksheet_set_paper(SELF.ActiveSheet,paper_type_)
    end

xlsxwriter.SetCenterHorizontally   PROCEDURE()
  CODE
    worksheet_center_horizontally(SELF.ActiveSheet)

xlsxwriter.SetCenterVertically     PROCEDURE()
  CODE
    worksheet_center_vertically(SELF.ActiveSheet)

xlsxwriter.SetPageView             PROCEDURE()
  CODE
    worksheet_set_page_view(SELF.ActiveSheet)

xlsxwriter.SetStartPage            PROCEDURE(SHORT start_page_)
  CODE
    worksheet_set_start_page(SELF.ActiveSheet,start_page_)

xlsxwriter.SetPrintScale           PROCEDURE(SHORT scale_)
  CODE
    worksheet_set_print_scale(SELF.ActiveSheet,scale_)

xlsxwriter.SetHeader   PROCEDURE(STRING string_,<REAL margin_>,<STRING image_left_>,<STRING image_center_>,<STRING image_right_>)
options  GROUP(XLSX:HF_OPTIONS)
         END
image_left   CSTRING(261)
image_center CSTRING(261)
image_right  CSTRING(261)

  CODE

  SELF.ToUTF8(string_)
  if omitted(3) and omitted(4) and omitted(5) and omitted(6)
    if SELF.IsChartsheet
      return chartsheet_set_header(SELF.ActiveSheet,SELF.cstr)
    else
      return worksheet_set_header(SELF.ActiveSheet,SELF.cstr)
    end
  else
    if ~omitted(3)
      options.margin = margin_/2.54
    end
    if ~omitted(4)
      image_left         = clip(image_left_)
      options.image_left = address(image_left)
    end
    if ~omitted(5)
      image_center       = clip(image_center_)
      options.image_center = address(image_center)
    end
    if ~omitted(6)
      image_right         = clip(image_right_)
      options.image_right = address(image_right)
    end
    if SELF.IsChartsheet
      return chartsheet_set_header_opt(SELF.ActiveSheet,SELF.cstr,options)
    else
      return worksheet_set_header_opt(SELF.ActiveSheet,SELF.cstr,options)
    end
  end

xlsxwriter.SetFooter   PROCEDURE(STRING string_,<REAL margin_>,<STRING image_left_>,<STRING image_center_>,<STRING image_right_>)
options  GROUP(XLSX:HF_OPTIONS)
         END
image_left   CSTRING(261)
image_center CSTRING(261)
image_right  CSTRING(261)
  CODE

  SELF.ToUTF8(string_)
  if omitted(3) and omitted(4) and omitted(5) and omitted(6)
    if SELF.IsChartsheet
      return chartsheet_set_footer(SELF.ActiveSheet,SELF.cstr)
    else
      return worksheet_set_footer(SELF.ActiveSheet,SELF.cstr)
    end
  else
    if ~omitted(3)
      options.margin = margin_/2.54
    end
    if ~omitted(4)
      image_left         = clip(image_left_)
      options.image_left = address(image_left)
    end
    if ~omitted(5)
      image_center       = clip(image_center_)
      options.image_center = address(image_center)
    end
    if ~omitted(6)
      image_right         = clip(image_right_)
      options.image_right = address(image_right)
    end

    if SELF.IsChartsheet
      return chartsheet_set_footer_opt(SELF.ActiveSheet,SELF.cstr,options)
    else
      return worksheet_set_footer_opt(SELF.ActiveSheet,SELF.cstr,options)
    end
  end

xlsxwriter.SetMargins  PROCEDURE(<REAL left_>,<REAL right_>,<REAL top_>,<REAL bottom_>)
m_left   REAL(-1)
m_right  REAL(-1)
m_top    REAL(-1)
m_bottom REAL(-1)
  CODE
    if ~omitted(2)
      m_left=left_/2.54
    end
    if ~omitted(3)
      m_right=right_/2.54
    end
    if ~omitted(4)
      m_top=top_/2.54
    end
    if ~omitted(5)
      m_bottom=bottom_/2.54
    end

    if SELF.IsChartsheet
      chartsheet_set_margins(SELF.ActiveSheet,m_left,m_right,m_top,m_bottom)
    else
      worksheet_set_margins(SELF.ActiveSheet,m_left,m_right,m_top,m_bottom)
    end

xlsxwriter.SetCommentsAuthor   PROCEDURE(STRING string_)
  CODE
    SELF.ToUTF8(string_)
    return worksheet_set_comments_author(SELF.ActiveSheet,SELF.cstr)

xlsxwriter.DataValidation PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_,BYTE validate_,BYTE criteria_,STRING value_,<STRING maximum_value_>,<BYTE ignore_blank_>,<BYTE show_input_>,<BYTE show_error_>,<BYTE error_type_>,<BYTE dropdown_>,<STRING input_title_>,<STRING input_message_>,<STRING error_title_>,<STRING error_message_>)

validation      GROUP
validate          BYTE
criteria          BYTE
ignore_blank      BYTE
show_input        BYTE
show_error        BYTE
error_type        BYTE
dropdown          BYTE
padding           BYTE
value_number      REAL
value_formula     LONG
value_list        LONG
value_datetime    GROUP(XLSX:datetime)
                  END
minimum_number    REAL
minimum_formula   LONG
minimum_padding   LONG
minimum_datetime  GROUP(XLSX:datetime)
                  END
maximum_number    REAL
maximum_formula   LONG
maximum_padding   LONG
maximum_datetime  GROUP(XLSX:datetime)
                  END
input_title       LONG
input_message     LONG
error_title       LONG
error_message     LONG
                END

Dim:value_list          LONG,DIM(128)
Cstr:value_list         CSTRING(511),DIM(128)
Cstr:value_formula      CSTRING(8193)
Cstr:minimum_formula    CSTRING(8193)
Cstr:maximum_formula    CSTRING(8193)
Cstr:input_title        CSTRING(65)
Cstr:input_message      CSTRING(511)
Cstr:error_title        CSTRING(65)
Cstr:error_message      CSTRING(511)

  CODE

    validation.validate=validate_
    validation.criteria=criteria_

    case validate_
    of XLSX:VALIDATION_TYPE_INTEGER
    orof XLSX:VALIDATION_TYPE_DECIMAL
    orof XLSX:VALIDATION_TYPE_LENGHT
      if ~omitted(9) and (criteria_=XLSX:VALIDATION_CRITERIA_BETWEEN or criteria_=XLSX:VALIDATION_CRITERIA_NOT_BETWEEN)
        validation.minimum_number=value_
        validation.maximum_number=maximum_value_
      else
        validation.value_number=value_
      end
    of XLSX:VALIDATION_TYPE_DATE
      if ~omitted(9) and (criteria_=XLSX:VALIDATION_CRITERIA_BETWEEN or criteria_=XLSX:VALIDATION_CRITERIA_NOT_BETWEEN)
        XLSX:FormDateTime(validation.minimum_datetime,value_,0)
        XLSX:FormDateTime(validation.maximum_datetime,maximum_value_,0)
      else
        XLSX:FormDateTime(validation.value_datetime,value_,0)
      end
    of XLSX:VALIDATION_TYPE_TIME
      if ~omitted(9) and (criteria_=XLSX:VALIDATION_CRITERIA_BETWEEN or criteria_=XLSX:VALIDATION_CRITERIA_NOT_BETWEEN)
        XLSX:FormDateTime(validation.minimum_datetime,0,value_)
        XLSX:FormDateTime(validation.maximum_datetime,0,maximum_value_)
      else
        XLSX:FormDateTime(validation.value_datetime,0,value_)
      end
    of XLSX:VALIDATION_TYPE_LIST
      loop i#=1 to len(value_)
        if value_[i#]=';' or i#=len(value_)
          if value_[i#]=';'
            e#=i#-1
          else
            e#=i#
          end
          if e#>=s#+1
            SELF.ToUTF8(value_[s#+1 : e#])
            Cstr:value_list[dim#+1]=SELF.Cstr
            Dim:value_list[dim#+1]=address(Cstr:value_list[dim#+1])
            dim#+=1
          end
          s#=i#
        end
      end
      validation:value_list=address(Dim:value_list)
    of XLSX:VALIDATION_TYPE_INTEGER_FORMULA
    orof XLSX:VALIDATION_TYPE_DECIMAL_FORMULA
    orof XLSX:VALIDATION_TYPE_LIST_FORMULA
    orof XLSX:VALIDATION_TYPE_DATE_FORMULA
    orof XLSX:VALIDATION_TYPE_TIME_FORMULA
    orof XLSX:VALIDATION_TYPE_LENGHT_FORMULA
    orof XLSX:VALIDATION_TYPE_CUSTOM_FORMULA
      if ~omitted(9) and (criteria_=XLSX:VALIDATION_CRITERIA_BETWEEN or criteria_=XLSX:VALIDATION_CRITERIA_NOT_BETWEEN)
        SELF.ToUTF8(value_)
        Cstr:minimum_formula=SELF.Cstr
        validation.minimum_formula=address(Cstr:minimum_formula)
        SELF.ToUTF8(maximum_value_)
        Cstr:maximum_formula=SELF.Cstr
        validation.maximum_formula=address(Cstr:maximum_formula)
      else
        SELF.ToUTF8(value_)
        Cstr:value_formula=SELF.Cstr
        validation.value_formula=address(Cstr:value_formula)
      end
    end

    if ~omitted(10)
      validation.ignore_blank=ignore_blank_
    end
    if ~omitted(11)
      validation.show_input=show_input_
    end
    if ~omitted(12)
      validation.show_error=show_error_
    end
    if ~omitted(13)
      validation.error_type=error_type_
    end
    if ~omitted(14)
      validation.dropdown=dropdown_
    end
    if ~omitted(15)
      SELF.ToUTF8(input_title_)
      Cstr:input_title=SELF.Cstr
      validation.input_title=address(Cstr:input_title)
    end
    if ~omitted(16)
      SELF.ToUTF8(input_message_)
      Cstr:input_message=SELF.Cstr
      validation.input_message=address(Cstr:input_message)
    end
    if ~omitted(17)
      SELF.ToUTF8(error_title_)
      Cstr:error_title=SELF.Cstr
      validation.error_title=address(Cstr:error_title)
    end
    if ~omitted(18)
      SELF.ToUTF8(error_message_)
      Cstr:error_message=SELF.Cstr
      validation.error_message=address(Cstr:error_message)
    end

    if first_row_=last_row_ and first_col_=last_col_
      return worksheet_data_validation_cell(SELF.ActiveSheet,first_row_-1,first_col_-1,address(validation))
    else
      return worksheet_data_validation_range(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1,address(validation))
    end

xlsxwriter.ConditionalFormat PROCEDURE(LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_,BYTE type_,BYTE criteria_,<REAL value_>,<STRING value_string_>,|
                    <REAL min_value_>,<STRING min_value_string_>,<BYTE min_rule_type_>,<LONG min_color_>,|
                    <REAL mid_value_>,<STRING mid_value_string_>,<BYTE mid_rule_type_>,<LONG mid_color_>,|
                    <REAL max_value_>,<STRING max_value_string_>,<BYTE max_rule_type_>,<LONG max_color_>,|
                    <LONG bar_color_>,<BYTE bar_only_>,<BYTE data_bar_2010_>,<BYTE bar_solid_>,|
                    <LONG bar_negative_color_>,<LONG bar_border_color_>,<LONG bar_negative_border_color_>,<LONG bar_negative_color_same_>,<LONG bar_negative_border_color_same>,|
                    <BYTE bar_no_border_>,<BYTE bar_direction_>,<BYTE bar_axis_position_>,<LONG bar_axis_color_>,|
                    <BYTE icon_style_>,<BYTE reverse_icons_>,<BYTE icons_only_>,<BYTE stop_if_true_>)

conditional      GROUP
type              BYTE
criteria          BYTE
padding1          SHORT
padding2          LONG

value             REAL

value_string      LONG
format            LONG

min_value         REAL

min_value_string  LONG
min_rule_type     BYTE
padding3          BYTE
padding4          SHORT

min_color         LONG
padding5          LONG

mid_value         REAL

mid_value_string  LONG
mid_rule_type     BYTE
padding6          BYTE
padding7          SHORT

mid_color         LONG
padding8          LONG

max_value         REAL

max_value_string  LONG
max_rule_type     BYTE
padding9          BYTE
padding10         SHORT

max_color         LONG
bar_color         LONG

bar_only          BYTE
data_bar_2010     BYTE
bar_solid         BYTE
padding11         BYTE
bar_negative_color LONG

bar_border_color  LONG
bar_negative_border_color  LONG

bar_negative_color_same BYTE
bar_negative_border_color_same BYTE
bar_no_border     BYTE
bar_direction     BYTE
bar_axis_position BYTE
padding12         BYTE
padding13         SHORT

bar_axis_color    LONG
icon_style        BYTE
reverse_icons     BYTE
icons_only        BYTE
padding14         BYTE
multi_range       LONG
stop_if_true      BYTE

                END
Cstr:value_string        CSTRING(8193)
Cstr:min_value_string    CSTRING(8193)
Cstr:mid_value_string    CSTRING(8193)
Cstr:max_value_string    CSTRING(8193)

  CODE

    conditional.type=type_
    conditional.criteria=criteria_
    conditional.format=SELF.ActiveFormat

    if ~omitted(8)
      conditional.value=value_
    end
    if ~omitted(9)
      SELF.ToUTF8(clip(value_string_))
      Cstr:value_string = SELF.Cstr
      conditional.value_string = address(Cstr:value_string)
    end

    if ~omitted(10)
      conditional.min_value=min_value_
    end
    if ~omitted(11)
      SELF.ToUTF8(clip(min_value_string_))
      Cstr:min_value_string = SELF.Cstr
      conditional.min_value_string = address(Cstr:min_value_string)
    end
    if ~omitted(12)
      conditional.min_rule_type=min_rule_type_
    end
    if ~omitted(13)
      conditional.min_color=XLSX:RGBColor(min_color_)
    end

    if ~omitted(14)
      conditional.mid_value=mid_value_
    end
    if ~omitted(15)
      SELF.ToUTF8(clip(mid_value_string_))
      Cstr:mid_value_string = SELF.Cstr
      conditional.mid_value_string = address(Cstr:mid_value_string)
    end
    if ~omitted(16)
      conditional.mid_rule_type=mid_rule_type_
    end
    if ~omitted(17)
      conditional.mid_color=XLSX:RGBColor(mid_color_)
    end

    if ~omitted(18)
      conditional.max_value=max_value_
    end
    if ~omitted(19)
      SELF.ToUTF8(clip(max_value_string_))
      Cstr:max_value_string = SELF.Cstr
      conditional.max_value_string = address(Cstr:max_value_string)
    end
    if ~omitted(20)
      conditional.max_rule_type=max_rule_type_
    end
    if ~omitted(21)
      conditional.max_color=XLSX:RGBColor(max_color_)
    end

    if ~omitted(22)
      conditional.bar_color=XLSX:RGBColor(bar_color_)
    end
    if ~omitted(23)
      conditional.bar_only=bar_only_
    end
    if ~omitted(24)
      conditional.data_bar_2010=data_bar_2010_
    end
    if ~omitted(25)
      conditional.bar_solid=bar_solid_
    end

    if ~omitted(26)
      conditional.bar_negative_color=XLSX:RGBColor(bar_negative_color_)
    end
    if ~omitted(27)
      conditional.bar_border_color=XLSX:RGBColor(bar_border_color_)
    end
    if ~omitted(28)
      conditional.bar_negative_border_color=XLSX:RGBColor(bar_negative_border_color_)
    end
    if ~omitted(29)
      conditional.bar_negative_color_same=XLSX:RGBColor(bar_negative_color_same_)
    end
    if ~omitted(30)
      conditional.bar_negative_border_color_same=XLSX:RGBColor(bar_negative_border_color_same)
    end

    if ~omitted(31)
      conditional.bar_no_border=bar_no_border_
    end
    if ~omitted(32)
      conditional.bar_direction=bar_direction_
    end
    if ~omitted(33)
      conditional.bar_axis_position=bar_axis_position_
    end
    if ~omitted(34)
      conditional.bar_axis_color=XLSX:RGBColor(bar_axis_color_)
    end
    if ~omitted(35)
      conditional.icon_style=icon_style_
    end
    if ~omitted(36)
      conditional.reverse_icons=reverse_icons_
    end
    if ~omitted(37)
      conditional.icons_only=icons_only_
    end
    if ~omitted(38)
      conditional.stop_if_true=stop_if_true_
    end

    if first_row_=last_row_ and first_col_=last_col_
      return worksheet_conditional_format_cell(SELF.ActiveSheet,first_row_-1,first_col_-1,address(conditional))
    else
      return worksheet_conditional_format_range(SELF.ActiveSheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1,address(conditional))
    end

xlsxwriter.Protect        PROCEDURE(<STRING password_>,<BYTE no_select_locked_cells_>,<BYTE no_select_unlocked_cells_>,|
                            <BYTE format_cells_>,<BYTE format_columns_>,<BYTE format_rows_>,<BYTE insert_columns_>,<BYTE insert_rows_>,<BYTE insert_hyperlinks_>,|
                            <BYTE delete_columns_>,<BYTE delete_rows_>,<BYTE sort_>,<BYTE autofilter_>,<BYTE pivot_tables_>,<BYTE scenarios_>,<BYTE objects_>,<BYTE no_content_>,<BYTE no_objects_>)
protection             GROUP
no_select_locked_cells   BYTE
no_select_unlocked_cells BYTE
format_cells             BYTE
format_columns           BYTE
format_rows              BYTE
insert_columns           BYTE
insert_rows              BYTE
insert_hyperlinks        BYTE
delete_columns           BYTE
delete_rows              BYTE
sort                     BYTE
autofilter               BYTE
pivot_tables             BYTE
scenarios                BYTE
objects                  BYTE
no_content               BYTE
no_objects               BYTE
                       END
cpassword              &CSTRING
  CODE

    if ~omitted(2)
      cpassword &=new(cstring(len(password_)+1))
      cpassword=password_
    end
    if ~omitted(3)
      protection.no_select_locked_cells = no_select_locked_cells_
    end
    if ~omitted(4)
      protection.no_select_unlocked_cells = no_select_unlocked_cells_
    end
    if ~omitted(5)
      protection.format_cells = format_cells_
    end
    if ~omitted(6)
      protection.format_columns = format_columns_
    end
    if ~omitted(7)
      protection.format_rows = format_rows_
    end
    if ~omitted(8)
      protection.insert_columns = insert_columns_
    end
    if ~omitted(9)
      protection.insert_rows = insert_rows_
    end
    if ~omitted(10)
      protection.insert_hyperlinks = insert_hyperlinks_
    end
    if ~omitted(11)
      protection.delete_columns = delete_columns_
    end
    if ~omitted(12)
      protection.no_select_locked_cells = no_select_locked_cells_
    end
    if ~omitted(13)
      protection.sort = sort_
    end
    if ~omitted(14)
      protection.autofilter = autofilter_
    end
    if ~omitted(15)
      protection.pivot_tables = pivot_tables_
    end
    if ~omitted(16)
      protection.scenarios = scenarios_
    end
    if ~omitted(17)
      protection.objects = objects_
    end
    if ~omitted(18)
      protection.no_content = no_content_
    end
    if ~omitted(19)
      protection.no_objects = no_objects_
    end

    if ~omitted(2)
      if SELF.IsChartsheet
        chartsheet_protect(SELF.ActiveSheet,address(cpassword),address(protection))
      else
        worksheet_protect(SELF.ActiveSheet,address(cpassword),address(protection))
      end
      dispose(cpassword)
    else
      if SELF.IsChartsheet
        chartsheet_protect(SELF.ActiveSheet,0,address(protection))
      else
        worksheet_protect(SELF.ActiveSheet,0,address(protection))
      end
    end

xlsxwriter.IgnoreErrors   PROCEDURE(BYTE type_,STRING range_)
  CODE
    SELF.ToUTF8(clip(range_))
    return worksheet_ignore_errors(SELF.ActiveSheet,type_,SELF.Cstr)

xlsxwriter.StrError PROCEDURE(LONG error_num_)
  CODE
    return lxw_strerror(error_num_)

xlsxchart.Construct       PROCEDURE
  CODE

xlsxchart.Destruct        PROCEDURE
  CODE

xlsxchart.AddChart        PROCEDURE(*xlsxwriter xlsxwriter_,BYTE chart_type_)
  CODE
    SELF.Chart = workbook_add_chart(xlsxwriter_.workbook,chart_type_)
    SELF.xlsx &= xlsxwriter_
    SELF.XAxis=chart_axis_get(SELF.Chart,0)
    SELF.YAxis=chart_axis_get(SELF.Chart,1)

xlsxchart.AddSeries       PROCEDURE
  CODE
    return chart_add_series(SELF.Chart,0,0)

xlsxchart.SetCategories       PROCEDURE(LONG series_,*CSTRING Sheetname_,LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_)
  CODE
    chart_series_set_categories(series_,sheetname_,first_row_-1,first_col_-1,last_row_-1,last_col_-1)

xlsxchart.SetValues       PROCEDURE(LONG series_,*CSTRING Sheetname_,LONG first_row_,SHORT first_col_,LONG last_row_,SHORT last_col_)
  CODE
    chart_series_set_values(series_,sheetname_,first_row_-1,first_col_-1,last_row_-1,last_col_-1)

xlsxchart.SetName      PROCEDURE(LONG series_,STRING Name_)
  CODE
    SELF.xlsx.ToUTF8(Name_)
    chart_series_set_name(series_,SELF.xlsx.cstr)

xlsxchart.SetNameRange      PROCEDURE(LONG series_,*CSTRING Sheetname_,LONG row_,SHORT col_)
  CODE
    chart_series_set_name_range(series_,Sheetname_,row_-1,col_-1)

xlsxchart.SetLine PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE

    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_series_set_line(series_,line_)

xlsxchart.SetFill PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
fill_   GROUP(XLSX:chart_fill)
  END

  CODE

    XLSX:FormFill(fill_,color_,none_,transparency_)
    chart_series_set_fill(series_,fill_)

xlsxchart.SetPattern PROCEDURE(LONG series_,LONG fg_color_,LONG bg_color_,BYTE type_)
pattern_ GROUP(XLSX:chart_pattern)
  END

  CODE

    pattern_.fg_color=XLSX:RGBColor(fg_color_)
    pattern_.bg_color=XLSX:RGBColor(bg_color_)
    pattern_.type=type_

    chart_series_set_pattern(series_,pattern_)

xlsxchart.SetInvertIfNegative PROCEDURE(LONG series_)
  CODE
    chart_series_set_invert_if_negative(series_)

xlsxchart.SetMarkerType PROCEDURE(LONG series_,BYTE type_)
  CODE
    chart_series_set_marker_type(series_,type_)

xlsxchart.SetMarkerSize PROCEDURE(LONG series_,BYTE size_)
  CODE
    chart_series_set_marker_size(series_,size_)

xlsxchart.SetMarkerLine PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE

    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_series_set_marker_line(series_,line_)

xlsxchart.SetMarkerFill PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
fill_   GROUP(XLSX:chart_fill)
  END

  CODE

    XLSX:FormFill(fill_,color_,none_,transparency_)
    chart_series_set_marker_fill(series_,fill_)

xlsxchart.SetMarkerPattern PROCEDURE(LONG series_,LONG fg_color_,LONG bg_color_,BYTE type_)
pattern_ GROUP(XLSX:chart_pattern)
  END

  CODE

    pattern_.fg_color=XLSX:RGBColor(fg_color_)
    pattern_.bg_color=XLSX:RGBColor(bg_color_)
    pattern_.type=type_

    chart_series_set_marker_pattern(series_,pattern_)

xlsxchart.SetSmooth PROCEDURE(LONG series_,BYTE smooth_)
  CODE
    chart_series_set_smooth(series_,smooth_)

xlsxchart.SetLabels PROCEDURE(LONG series_,BYTE name_,BYTE category_,BYTE value_)
  CODE
    chart_series_set_labels_options(series_,name_,category_,value_)

xlsxchart.SetLabelsSeparator PROCEDURE(LONG series_,BYTE separator_)
  CODE
    chart_series_set_labels_separator(series_,separator_)

xlsxchart.SetLabelsPosition PROCEDURE(LONG series_,BYTE position_)
  CODE
    chart_series_set_labels_position(series_,position_)

xlsxchart.SetLabelsLeaderLine PROCEDURE(LONG series_)
  CODE
    chart_series_set_labels_leader_line(series_)

xlsxchart.SetLabelsLegend PROCEDURE(LONG series_)
  CODE
    chart_series_set_labels_legend(series_)

xlsxchart.SetLabelsPercentage PROCEDURE(LONG series_)
  CODE
    chart_series_set_labels_percentage(series_)

xlsxchart.SetLabelsFont      PROCEDURE(LONG series_,<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
font_name CSTRING(101)
font_ GROUP(XLSX:chart_font)
 END
  CODE
    if ~omitted(3)
      font_name=name_
      font_.name=address(font_name)
    end
    XLSX:FormFont(font_,size_,style_,rotation_,color_)
    chart_series_set_labels_font(series_,font_)

xlsxchart.SetLabelsNumFormat      PROCEDURE(LONG series_,<STRING ExcelMask_>,<STRING picture_>)
format_ CSTRING(101)
  CODE

    format_=clip(ExcelMask_)

    COMPILE('***',_TPictureClassPresent_)

    if clip(picture_)<>'' and lower(sub(left(picture_),1,2))<>'@s'
      pic#=SELF.xlsx.Picture.TakePicture(picture_)
      format_=clip(SELF.xlsx.Picture.ExcelMask)
    end

    ***

    SELF.xlsx.ToUTF8(format_)
    chart_series_set_labels_num_format(series_,SELF.xlsx.Cstr)

xlsxchart.SetLabelsLine PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE

    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_series_set_labels_line(series_,line_)

xlsxchart.SetLabelsFill PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
fill_   GROUP(XLSX:chart_fill)
  END

  CODE

    XLSX:FormFill(fill_,color_,none_,transparency_)
    chart_series_set_labels_fill(series_,fill_)

xlsxchart.SetLabelsPattern PROCEDURE(LONG series_,LONG fg_color_,LONG bg_color_,BYTE type_)
pattern_ GROUP(XLSX:chart_pattern)
  END

  CODE

    pattern_.fg_color=XLSX:RGBColor(fg_color_)
    pattern_.bg_color=XLSX:RGBColor(bg_color_)
    pattern_.type=type_

    chart_series_set_labels_pattern(series_,pattern_)

xlsxchart.SetTrendline       PROCEDURE(LONG series_,BYTE type_,BYTE value_)
  CODE
    chart_series_set_trendline(series_,type_,value_)

xlsxchart.SetTrendlineForecast PROCEDURE(LONG series_,REAL forward_,REAL backward_)
  CODE
    chart_series_set_trendline_forecast(series_,forward_,backward_)

xlsxchart.SetTrendlineEquation  PROCEDURE(LONG series_)
  CODE
    chart_series_set_trendline_equation(series_)

xlsxchart.SetTrendlineRSquared  PROCEDURE(LONG series_)
  CODE
    chart_series_set_trendline_r_squared(series_)

xlsxchart.SetTrendlineIntercept  PROCEDURE(LONG series_,REAL intercept_)
  CODE
    chart_series_set_trendline_intercept(series_,intercept_)

xlsxchart.SetTrendlineName  PROCEDURE(LONG series_,STRING name_)
  CODE
    SELF.xlsx.ToUTF8(Name_)
    chart_series_set_trendline_name(series_,SELF.xlsx.cstr)

xlsxchart.SetTrendlineLine PROCEDURE(LONG series_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE

    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_series_set_trendline_line(series_,line_)

xlsxchart.SetTitleName      PROCEDURE(STRING Name_)
  CODE
    SELF.xlsx.ToUTF8(Name_)
    chart_title_set_name(SELF.chart,SELF.xlsx.cstr)

xlsxchart.SetTitleNameRange      PROCEDURE(*CSTRING Sheetname_,LONG row_,SHORT col_)
  CODE
    chart_title_set_name_range(SELF.chart,Sheetname_,row_-1,col_-1)

xlsxchart.SetTitleNameFont      PROCEDURE(<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
font_name CSTRING(101)
font_ GROUP(XLSX:chart_font)
 END

  CODE
    if ~omitted(2)
      font_name=name_
      font_.name=address(font_name)
    end
    XLSX:FormFont(font_,size_,style_,rotation_,color_)
    chart_title_set_name_font(SELF.chart,font_)

xlsxchart.SetTitleOff       PROCEDURE
  CODE
    chart_title_off(SELF.chart)

xlsxchart.SetLegendPosition PROCEDURE(BYTE position_)
  CODE
    chart_legend_set_position(SELF.chart,position_)

xlsxchart.SetLegendFont      PROCEDURE(<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
font_name CSTRING(101)
font_ GROUP(XLSX:chart_font)
 END

  CODE
    if ~omitted(2)
      font_name=name_
      font_.name=address(font_name)
    end
    XLSX:FormFont(font_,size_,style_,rotation_,color_)
    chart_legend_set_font(SELF.chart,font_)

xlsxchart.SetChartareaLine PROCEDURE(<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE

    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_chartarea_set_line(SELF.chart,line_)

xlsxchart.SetChartareaFill PROCEDURE(<LONG color_>,<BYTE none_>,<BYTE transparency_>)
fill_   GROUP(XLSX:chart_fill)
  END

  CODE

    XLSX:FormFill(fill_,color_,none_,transparency_)
    chart_chartarea_set_fill(SELF.chart,fill_)

xlsxchart.SetChartareaPattern PROCEDURE(LONG fg_color_,LONG bg_color_,BYTE type_)
pattern_ GROUP(XLSX:chart_pattern)
  END

  CODE

    pattern_.fg_color=XLSX:RGBColor(fg_color_)
    pattern_.bg_color=XLSX:RGBColor(bg_color_)
    pattern_.type=type_

    chart_chartarea_set_pattern(SELF.chart,pattern_)

xlsxchart.SetPlotareaLine PROCEDURE(<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE
    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_plotarea_set_line(SELF.chart,line_)

xlsxchart.SetPlotareaFill PROCEDURE(<LONG color_>,<BYTE none_>,<BYTE transparency_>)
fill_   GROUP(XLSX:chart_fill)
  END

  CODE
    XLSX:FormFill(fill_,color_,none_,transparency_)
    chart_plotarea_set_fill(SELF.chart,fill_)

xlsxchart.SetPlotareaPattern PROCEDURE(LONG fg_color_,LONG bg_color_,BYTE type_)
pattern_ GROUP(XLSX:chart_pattern)
  END

  CODE

    pattern_.fg_color=XLSX:RGBColor(fg_color_)
    pattern_.bg_color=XLSX:RGBColor(bg_color_)
    pattern_.type=type_

    chart_plotarea_set_pattern(SELF.chart,pattern_)

xlsxchart.SetStyle PROCEDURE(BYTE style_)
  CODE
    chart_set_style(SELF.chart,style_)

xlsxchart.SetTable PROCEDURE(BYTE horizontal_,BYTE vertical_,BYTE outline_,BYTE legend_keys_)
  CODE

    chart_set_table(SELF.chart)
    chart_set_table_grid(SELF.chart,horizontal_,vertical_,outline_,legend_keys_)

xlsxchart.SetDropLines PROCEDURE(<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE
    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_set_drop_lines(SELF.chart,line_)

xlsxchart.SetHighLowLines PROCEDURE(<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE
    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_set_high_low_lines(SELF.chart,line_)

xlsxchart.SetOverlap PROCEDURE(SHORT overlap_)
  CODE
    chart_set_series_overlap(SELF.chart,overlap_)

xlsxchart.SetGap PROCEDURE(USHORT gap_)
  CODE
    chart_set_series_gap(SELF.chart,gap_)

xlsxchart.SetRotation PROCEDURE(USHORT rotation_)
  CODE
    chart_set_rotation(SELF.chart,rotation_)

xlsxchart.SetHoleSize PROCEDURE(BYTE size_)
  CODE
    chart_set_hole_size(SELF.chart,size_)

xlsxchart.ShowBlanksAs PROCEDURE(BYTE option_)
  CODE
    chart_show_blanks_as(SELF.chart,option_)

xlsxchart.ShowHiddenData PROCEDURE()
  CODE
    chart_show_hidden_data(SELF.chart)

xlsxchart.SetAxisName                  PROCEDURE(LONG axis_,STRING name_)
  CODE
    SELF.xlsx.ToUTF8(Name_)
    chart_axis_set_name(axis_,SELF.xlsx.cstr)

xlsxchart.SetAxisNameRange             PROCEDURE(LONG axis_,*CSTRING sheetname_,LONG row_,SHORT col_)
  CODE
    chart_axis_set_name_range(axis_,Sheetname_,row_-1,col_-1)

xlsxchart.SetAxisNameFont              PROCEDURE(LONG axis_,<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
font_name CSTRING(101)
font_ GROUP(XLSX:chart_font)
 END
  CODE
    if ~omitted(3)
      font_name=name_
      font_.name=address(font_name)
    end
    XLSX:FormFont(font_,size_,style_,rotation_,color_)
    chart_axis_set_name_font(axis_,font_)

xlsxchart.SetAxisNumFont               PROCEDURE(LONG axis_,<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
font_name CSTRING(101)
font_ GROUP(XLSX:chart_font)
 END
  CODE
    if ~omitted(3)
      font_name=name_
      font_.name=address(font_name)
    end
    XLSX:FormFont(font_,size_,style_,rotation_,color_)
    chart_axis_set_num_font(axis_,font_)

xlsxchart.SetAxisNumFormat      PROCEDURE(LONG axis_,<STRING ExcelMask_>,<STRING picture_>)
format_ CSTRING(101)
  CODE

    format_=clip(ExcelMask_)

    COMPILE('***',_TPictureClassPresent_)

    if clip(picture_)<>'' and lower(sub(left(picture_),1,2))<>'@s'
      pic#=SELF.xlsx.Picture.TakePicture(picture_)
      format_=clip(SELF.xlsx.Picture.ExcelMask)
    end

    ***
    SELF.xlsx.ToUTF8(format_)
    chart_axis_set_num_format(axis_,SELF.xlsx.Cstr)

xlsxchart.SetAxisLine                  PROCEDURE(LONG axis_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE
    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_axis_set_line(axis_,line_)

xlsxchart.SetAxisFill                  PROCEDURE(LONG axis_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
fill_   GROUP(XLSX:chart_fill)
  END

  CODE
    XLSX:FormFill(fill_,color_,none_,transparency_)
    chart_axis_set_fill(axis_,fill_)

xlsxchart.SetAxisPattern               PROCEDURE(LONG axis_,LONG fg_color_,LONG bg_color_,BYTE type_)
pattern_ GROUP(XLSX:chart_pattern)
  END

  CODE

    pattern_.fg_color=XLSX:RGBColor(fg_color_)
    pattern_.bg_color=XLSX:RGBColor(bg_color_)
    pattern_.type=type_

    chart_axis_set_pattern(axis_,pattern_)

xlsxchart.SetAxisReverse               PROCEDURE(LONG axis_)
  CODE
    chart_axis_set_reverse(axis_)

xlsxchart.SetAxisCrossing              PROCEDURE(LONG axis_,REAL value_)
  CODE
    chart_axis_set_crossing(axis_,value_)

xlsxchart.SetAxisCrossingMax           PROCEDURE(LONG axis_)
  CODE
    chart_axis_set_crossing_max(axis_)

xlsxchart.SetAxisCrossingMin           PROCEDURE(LONG axis_)
  CODE
    chart_axis_set_crossing_min(axis_)

xlsxchart.SetAxisOff                   PROCEDURE(LONG axis_)
  CODE
    chart_axis_off(axis_)

xlsxchart.SetAxisPosition              PROCEDURE(LONG axis_,BYTE position_)
  CODE
    chart_axis_set_position(axis_,position_)

xlsxchart.SetAxisLabelPosition         PROCEDURE(LONG axis_,BYTE position_)
  CODE
    chart_axis_set_label_position(axis_,position_)

xlsxchart.SetAxisLabelAlign            PROCEDURE(LONG axis_,BYTE align_)
  CODE
    chart_axis_set_label_align(axis_,align_)

xlsxchart.SetAxisMin                   PROCEDURE(LONG axis_,REAL min_)
  CODE
    chart_axis_set_min(axis_,min_)

xlsxchart.SetAxisMax                   PROCEDURE(LONG axis_,REAL max_)
  CODE
    chart_axis_set_max(axis_,max_)

xlsxchart.SetAxisLogBase               PROCEDURE(LONG axis_,SHORT log_base_)
  CODE
    chart_axis_set_log_base(axis_,log_base_)

xlsxchart.SetAxisMajorTickMark         PROCEDURE(LONG axis_,BYTE type_)
  CODE
    chart_axis_set_major_tick_mark(axis_,type_)

xlsxchart.SetAxisMinorTickMark         PROCEDURE(LONG axis_,BYTE type_)
  CODE
    chart_axis_set_minor_tick_mark(axis_,type_)

xlsxchart.SetAxisIntervalUnit          PROCEDURE(LONG axis_,SHORT unit_)
  CODE
    chart_axis_set_interval_unit(axis_,unit_)

xlsxchart.SetAxisIntervalTick          PROCEDURE(LONG axis_,SHORT type_)
  CODE
    chart_axis_set_interval_tick(axis_,type_)

xlsxchart.SetAxisMajorUnit             PROCEDURE(LONG axis_,REAL unit_)
  CODE
    chart_axis_set_major_unit(axis_,unit_)

xlsxchart.SetAxisMinorUnit             PROCEDURE(LONG axis_,REAL unit_)
  CODE
    chart_axis_set_minor_unit(axis_,unit_)

xlsxchart.SetAxisDisplayUnits          PROCEDURE(LONG axis_,BYTE type_)
  CODE
    chart_axis_set_display_units(axis_,type_)

xlsxchart.SetAxisDisplayUnitsVisible   PROCEDURE(LONG axis_,BYTE visible_)
  CODE
    chart_axis_set_display_units_visible(axis_,visible_)

xlsxchart.SetAxisMajorGridlinesVisible PROCEDURE(LONG axis_,BYTE visible_)
  CODE
    chart_axis_major_gridlines_set_visible(axis_,visible_)

xlsxchart.SetAxisMinorGridlinesVisible PROCEDURE(LONG axis_,BYTE visible_)
  CODE
    chart_axis_minor_gridlines_set_visible(axis_,visible_)

xlsxchart.SetAxisMajorGridlinesLine    PROCEDURE(LONG axis_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE
    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_axis_major_gridlines_set_line(axis_,line_)

xlsxchart.SetAxisMinorGridlinesLine    PROCEDURE(LONG axis_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE
    XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
    chart_axis_minor_gridlines_set_line(axis_,line_)

xlsxchart.GetErrorBars PROCEDURE(LONG series_,BYTE type_)
  CODE
    return chart_series_get_error_bars(series_,type_)

xlsxchart.SetErrorBars                 PROCEDURE(LONG error_bars_,BYTE type_,REAL value_)
  CODE
    chart_series_set_error_bars(error_bars_,type_,value_)

xlsxchart.SetErrorBarsDirection        PROCEDURE(LONG error_bars_,BYTE direction_)
  CODE
    chart_series_set_error_bars_direction(error_bars_,direction_)

xlsxchart.SetErrorBarsEndcap           PROCEDURE(LONG error_bars_,BYTE endcap_)
  CODE
    chart_series_set_error_bars_endcap(error_bars_,endcap_)

xlsxchart.SetErrorBarsLine             PROCEDURE(LONG error_bars_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE
    chart_series_set_error_bars_line(error_bars_,line_)

xlsxchart.SetPointLine                  PROCEDURE(BYTE num_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE
    if num_
      XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
      SELF.Points[num_].line=line_
      SELF.Points[num_].is_custom=1
    end

xlsxchart.SetPointFill                  PROCEDURE(BYTE num_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
fill_   GROUP(XLSX:chart_fill)
  END

  CODE
    if num_
      XLSX:FormFill(fill_,color_,none_,transparency_)
      SELF.Points[num_].fill=fill_
      SELF.Points[num_].is_custom=1
    end

xlsxchart.SetPointPattern               PROCEDURE(BYTE num_,LONG fg_color_,LONG bg_color_,BYTE type_)
pattern_ GROUP(XLSX:chart_pattern)
  END

  CODE

    if num_
      pattern_.fg_color=XLSX:RGBColor(fg_color_)
      pattern_.bg_color=XLSX:RGBColor(bg_color_)
      pattern_.type=type_
      SELF.Points[num_].pattern=pattern_
      SELF.Points[num_].is_custom=1
    end

xlsxchart.SetPoints                      PROCEDURE(LONG series_,BYTE limit_=255)
pointsd LONG,DIM(256)
points GROUP,DIM(256)
line    LONG
fill    LONG
pattern LONG
       END
  CODE
    clear(points)
    clear(pointsd)

    loop i#=1 to limit_
      if SELF.Points[i#].is_custom
        if SELF.Points[i#].line
          points[i#].line=address(SELF.Points[i#].line)
        end
        if SELF.Points[i#].fill
          points[i#].fill=address(SELF.Points[i#].fill)
        end
        if SELF.Points[i#].pattern
          points[i#].pattern=address(SELF.Points[i#].pattern)
        end
      end
      pointsd[i#]=address(points[i#])
    end
    return chart_series_set_points(series_,address(pointsd))

xlsxchart.SetCustomLabel               PROCEDURE(BYTE num_,<STRING value_>,<BYTE hide_>)
  CODE
    if num_
      SELF.xlsx.ToUTF8(value_)
      SELF.CustomLabels[num_].value=SELF.xlsx.Cstr
      SELF.CustomLabels[num_].hide=hide_
      SELF.CustomLabels[num_].is_custom=1
    end

xlsxchart.SetCustomLabelFont               PROCEDURE(BYTE num_,<STRING name_>,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
font_name CSTRING(101)
font_ GROUP(XLSX:chart_font)
 END
  CODE
    if num_
      if ~omitted(3)
        font_name=name_
        font_.name=address(font_name)
      end
      XLSX:FormFont(font_,size_,style_,rotation_,color_)
      SELF.CustomLabels[num_].font=font_
      SELF.CustomLabels[num_].is_custom=1
    end

xlsxchart.SetCustomLabelLine                  PROCEDURE(BYTE num_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
line_   GROUP(XLSX:chart_line_)
  END

  CODE
    if num_
      XLSX:FormLine(line_,color_,none_,width_,dash_type_,transparency_)
      SELF.CustomLabels[num_].line=line_
      SELF.CustomLabels[num_].is_custom=1
    end

xlsxchart.SetCustomLabelFill                  PROCEDURE(BYTE num_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
fill_   GROUP(XLSX:chart_fill)
  END

  CODE
    if num_
      XLSX:FormFill(fill_,color_,none_,transparency_)
      SELF.CustomLabels[num_].fill=fill_
      SELF.CustomLabels[num_].is_custom=1
    end

xlsxchart.SetCustomLabelPattern               PROCEDURE(BYTE num_,LONG fg_color_,LONG bg_color_,BYTE type_)
pattern_ GROUP(XLSX:chart_pattern)
  END

  CODE

    if num_
      pattern_.fg_color=XLSX:RGBColor(fg_color_)
      pattern_.bg_color=XLSX:RGBColor(bg_color_)
      pattern_.type=type_
      SELF.CustomLabels[num_].pattern=pattern_
      SELF.CustomLabels[num_].is_custom=1
    end

xlsxchart.SetCustomLabels                      PROCEDURE(LONG series_,BYTE limit_=255)
labelsd LONG,DIM(256)
labels GROUP,DIM(256)
value   LONG
hide    BYTE
padding BYTE
padding2 SHORT
font    LONG
line    LONG
fill    LONG
pattern LONG
       END
  CODE
    clear(labels)
    clear(labelsd)

    loop i#=1 to limit_
      if SELF.CustomLabels[i#].is_custom=1
        if SELF.CustomLabels[i#].value
          labels[i#].value=address(SELF.CustomLabels[i#].value)
        end
        labels[i#].hide=SELF.CustomLabels[i#].hide
        if SELF.CustomLabels[i#].font
          labels[i#].font=address(SELF.CustomLabels[i#].font)
        end
        if SELF.CustomLabels[i#].line
          labels[i#].line=address(SELF.CustomLabels[i#].line)
        end
        if SELF.CustomLabels[i#].fill
          labels[i#].fill=address(SELF.CustomLabels[i#].fill)
        end
        if SELF.CustomLabels[i#].pattern
          labels[i#].pattern=address(SELF.CustomLabels[i#].pattern)
        end
      end
      labelsd[i#]=address(labels[i#])
    end
    return chart_series_set_labels_custom(series_,address(labelsd))

xlsxchart.SetUpDownBars                  PROCEDURE(<*XLSX:chart_line_ up_bar_line_>,<*XLSX:chart_fill up_bar_fill_>,<*XLSX:chart_line_ down_bar_line_>,<*XLSX:chart_fill down_bar_fill_>)
  CODE
    chart_set_up_down_bars_format(SELF.chart,up_bar_line_,up_bar_fill_,down_bar_line_,down_bar_fill_)

xlsxchart.SetLegendSeriesToDelete         PROCEDURE(BYTE num_)
  CODE
    if num_
      loop i#=1 to maximum(SELF.ToDelete,1)
        if SELF.ToDelete[i#]=0
          SELF.ToDelete[i#]=num_
          break
        end
      end
    end

xlsxchart.DeleteLegendSeries             PROCEDURE()
ToDelete SHORT,DIM(256)
   CODE
     loop i#=1 to maximum(SELF.ToDelete,1)
       if SELF.ToDelete[i#]=0 then break.
       ToDelete[i#]=SELF.ToDelete[i#]-1
     end
     ToDelete[i#]=-1

     return chart_legend_delete_series(SELF.chart,address(ToDelete))

XLSX:FormDateTime PROCEDURE(*XLSX:datetime dt_,LONG date_,LONG time_)
  CODE
    dt_.year=year(date_)
    dt_.month=month(date_)
    dt_.day=day(date_)
    dt_.hour=int((time_-1)/360000)
    dt_.min=int((time_-1-dt_.hour*360000)/6000)
    dt_.sec=int((time_-1-dt_.hour*360000-dt_.min*6000)/100)

XLSX:FormLine PROCEDURE(*XLSX:chart_line_ line_,<LONG color_>,<BYTE none_>,<REAL width_>,<BYTE dash_type_>,<BYTE transparency_>)
  CODE
    if ~omitted(2)
      line_.color=XLSX:RGBColor(color_)
    end
    if ~omitted(3)
      line_.none=none_
    end
    if ~omitted(4)
      line_.width=width_
    end
    if ~omitted(5)
      line_.dash_type=dash_type_
    end
    if ~omitted(6)
      line_.transparency=transparency_
    end

XLSX:FormFill PROCEDURE(*XLSX:chart_fill fill_,<LONG color_>,<BYTE none_>,<BYTE transparency_>)
  CODE

    if ~omitted(2)
      fill_.color=XLSX:RGBColor(color_)
    end
    if ~omitted(3)
      fill_.none=none_
    end
    if ~omitted(4)
      fill_.transparency=transparency_
    end

XLSX:FormFont PROCEDURE(*XLSX:chart_font font_,<REAL size_>,<LONG style_>,<LONG rotation_>,<LONG color_>)
  CODE
    if ~omitted(2)
      font_.size=size_
    end
    if ~omitted(3)
      if BAND(style_,font:Regular)=font:Regular
        font_.bold=2                     ! Issue 199
      end
      if BAND(style_,font:Bold)=font:Bold
        font_.bold=1
      end
      if BAND(style_,font:Italic)=font:Italic
        font_.italic=1
      end
      if BAND(style_,font:UnderLine)=font:UnderLine
        font_.underline=1
      end
    end
    if ~omitted(4)
      font_.rotation=rotation_
    end
    if ~omitted(5)
      font_.color=XLSX:RGBColor(color_)
    end

XLSX:RGBColor PROCEDURE(LONG color_)
ColorBGR    GROUP,OVER(color_)
B               BYTE
G               BYTE
R               BYTE
C               BYTE
              END

ColorRes   ULONG

  CODE
    color_=XLSX:GetSystemColor(color_)
    if ~color_
      ColorRes = 1000000h
    else
      ColorRes = ColorBGR.B
      ColorRes = BShift(ColorRes, 8) + ColorBGR.G
      ColorRes = BShift(ColorRes, 8) + ColorBGR.R
    end
    return ColorRes

XLSX:GetSystemColor    PROCEDURE(LONG Color)

LOC:Ret    LONG

COLOR_BTNFACE              EQUATE(15)
COLOR_3DDKSHADOW           EQUATE(21)
COLOR_3DFACE               EQUATE(15)
COLOR_3DHILIGHT            EQUATE(20)
COLOR_3DLIGHT              EQUATE(22)
COLOR_3DSHADOW             EQUATE(16)
COLOR_ACTIVEBORDER         EQUATE(10)
COLOR_ACTIVECAPTION        EQUATE(2)
COLOR_APPWORKSPACE         EQUATE(12)
COLOR_BACKGROUND           EQUATE(1)
COLOR_BTNHIGHLIGHT         EQUATE(COLOR_3DHILIGHT)
COLOR_BTNSHADOW            EQUATE(16)
COLOR_BTNTEXT              EQUATE(18)
COLOR_CAPTIONTEXT          EQUATE(9)
COLOR_DESKTOP              EQUATE(1)
COLOR_GRAYTEXT             EQUATE(17)
COLOR_HIGHLIGHT            EQUATE(13)
COLOR_HIGHLIGHTTEXT        EQUATE(14)
COLOR_INACTIVEBORDER       EQUATE(11)
COLOR_INACTIVECAPTION      EQUATE(3)
COLOR_INACTIVECAPTIONTEXT  EQUATE(19)
COLOR_INFOBK               EQUATE(24)
COLOR_INFOTEXT             EQUATE(23)
COLOR_MENU                 EQUATE(4)
COLOR_MENUTEXT             EQUATE(7)
COLOR_SCROLLBAR            EQUATE(0)
COLOR_WINDOW               EQUATE(5)
COLOR_WINDOWFRAME          EQUATE(6)
COLOR_WINDOWTEXT           EQUATE(8)

   CODE
   case color
   of COLOR:SCROLLBAR
     LOC:Ret = XLSX:GetSysColor(COLOR_SCROLLBAR)
   of COLOR:BACKGROUND
     LOC:Ret = XLSX:GetSysColor(COLOR_BACKGROUND)
   of COLOR:ACTIVECAPTION
     LOC:Ret = XLSX:GetSysColor(COLOR_ACTIVECAPTION)
   of COLOR:INACTIVECAPTION
     LOC:Ret = XLSX:GetSysColor(COLOR_INACTIVECAPTION)
   of COLOR:MENU
     LOC:Ret = XLSX:GetSysColor(COLOR_MENU)
   of COLOR:WINDOW
     LOC:Ret = XLSX:GetSysColor(COLOR_WINDOW)
   of COLOR:WINDOWFRAME
     LOC:Ret = XLSX:GetSysColor(COLOR_WINDOWFRAME)
   of COLOR:MENUTEXT
     LOC:Ret = XLSX:GetSysColor(COLOR_MENUTEXT)
   of COLOR:WINDOWTEXT
     LOC:Ret = XLSX:GetSysColor(COLOR_WINDOWTEXT)
   of COLOR:CAPTIONTEXT
     LOC:Ret = XLSX:GetSysColor(COLOR_CAPTIONTEXT)
   of COLOR:ACTIVEBORDER
     LOC:Ret = XLSX:GetSysColor(COLOR_ACTIVEBORDER)
   of COLOR:INACTIVEBORDER
     LOC:Ret = XLSX:GetSysColor(COLOR_INACTIVEBORDER)
   of COLOR:APPWORKSPACE
     LOC:Ret = XLSX:GetSysColor(COLOR_APPWORKSPACE)
   of COLOR:HIGHLIGHT
     LOC:Ret = XLSX:GetSysColor(COLOR_HIGHLIGHT)
   of COLOR:HIGHLIGHTTEXT
     LOC:Ret = XLSX:GetSysColor(COLOR_HIGHLIGHTTEXT)
   of COLOR:BTNFACE
     LOC:Ret = XLSX:GetSysColor(COLOR_BTNFACE)
   of COLOR:BTNSHADOW
     LOC:Ret = XLSX:GetSysColor(COLOR_BTNSHADOW)
   of COLOR:GRAYTEXT
     LOC:Ret = XLSX:GetSysColor(COLOR_GRAYTEXT)
   of COLOR:BTNTEXT
     LOC:Ret = XLSX:GetSysColor(COLOR_BTNTEXT)
   of COLOR:INACTIVECAPTIONTEXT
     LOC:Ret = XLSX:GetSysColor(COLOR_INACTIVECAPTIONTEXT)
   of COLOR:BTNHIGHLIGHT
     LOC:Ret = XLSX:GetSysColor(COLOR_BTNHIGHLIGHT)
   else
     LOC:Ret = Color
   end
   return(LOC:Ret)

XLSX:Normalize PROCEDURE(STRING In_,BYTE valchar_)
  CODE

   l#=len(In_)
   if l#>31 then l#=31.
   if valchar_<32 or instring(chr(valchar_),'/\[]:*?''') then valchar_=95.
   loop i#=1 to l#
     if val(In_[i#])<32 or instring(In_[i#],'/\[]:*?')
       In_[i#]=chr(valchar_)
     end
     if (i#=1 or i#=l#) and val(In_[i#])=39
       In_[i#]=chr(valchar_)
     end
   end
   return In_[1:l#]